/*
 * FW_test.c
 *
 *  Created on: May 17, 2018
 *      Author: Tomas
 */

#include "FW_test.h"

int8_t checkMagneticSensor() {
	uint8_t error = 0;
	HAL_GPIO_WritePin( MAG_VDDIO_GPIO_Port, MAG_VDDIO_Pin, GPIO_PIN_SET );
	HAL_Delay( 10 );
	  hi2c1.Instance = I2C1;
	  hi2c1.Init.Timing = 0x00000202;
	  hi2c1.Init.OwnAddress1 = 0;
	  hi2c1.Init.AddressingMode = I2C_ADDRESSINGMODE_7BIT;
	  hi2c1.Init.DualAddressMode = I2C_DUALADDRESS_DISABLE;
	  hi2c1.Init.OwnAddress2 = 0;
	  hi2c1.Init.OwnAddress2Masks = I2C_OA2_NOMASK;
	  hi2c1.Init.GeneralCallMode = I2C_GENERALCALL_DISABLE;
	  hi2c1.Init.NoStretchMode = I2C_NOSTRETCH_DISABLE;
	  if (HAL_I2C_Init(&hi2c1) != HAL_OK)
	  {
		  error = 1;
	  }

	  if ( error == 1 ) {
		sendMsg( "Report: Cannot initialize magnetic sensor!!!" );
		return -1;

	  }
	  HAL_Delay( 10 );

	  if ( HAL_I2C_IsDeviceReady( &hi2c1, LIS3MDL_ADDR, 3, 2000 ) != HAL_OK ) {
		  sendMsg( "Report: Error communicating with magnetic sensor, not responding on I2C!!!" );
		  return -1;

	  }


	  HAL_StatusTypeDef sta;
		uint8_t data;
		sta = lis3mdl_write(&data, 1, 0x20);		//CTRL1

		if ( sta == HAL_ERROR ){
			 sendMsg( "Report: Error writing data to magnetic sensor!!!" );
			return -1;
		}



		data = 0b01000000;
		sta = lis3mdl_write(&data, 1, 0x21);		//CTRL2
		if ( sta == HAL_ERROR ){
			 sendMsg( "Report: Error writing data to magnetic sensor!!!" );
			return -1;
		}
		data = 0b00100100;
		sta = lis3mdl_write(&data, 1, 0x22);		//CTRL3
		if ( sta == HAL_ERROR ){
			 sendMsg( "Report: Error writing data to magnetic sensor!!!" );
			return -1;
		}
		data = 0b00000000;
		sta = lis3mdl_write(&data, 1, 0x23);		//CTRL4
		if ( sta == HAL_ERROR ){
			 sendMsg( "Report: Error writing data to magnetic sensor!!!" );
			return -1;
		}
		data = 0b01000000;
		sta = lis3mdl_write(&data, 1, 0x24);		//CTRL5
		if ( sta == HAL_ERROR ){
			 sendMsg( "Report: Error writing data to magnetic sensor!!!" );
			return -1;
		}

	  if ( sta != HAL_OK )  {
		  sendMsg( "Report: Error writing data to magnetic sensor!!!" );
		  return -1;
	  }


	  uint8_t v = 0;


	  mag_int = NO_INTERRUPT;
	  Mag3110 g;
	  getCurrentVal( &g );


	  int64_t start_time = HAL_GetTick();

	  while(1) {
		  if ( mag_int == INTERRUPT ) {
			  getCurrentVal( &g );
			  mag_int = NO_INTERRUPT;
			  v++;
		  }
		  if ( v == 3 ) {
			  break;
		  }

		  HAL_Delay( 500 );

		  if ( ( start_time + 8000 ) < HAL_GetTick() ) {
			  sendMsg( "Report: Interrupt timeout, no interrupt received" );
			  return -1;
		  }


	  }
	  return 1;
}

uint8_t getProvisioningInfo( char * deveui, char * dev_addr ) {
	uint8_t attempts = 0;
	#ifdef SIGFOX
		HAL_UART_Transmit( &huart2, "AT$PAC\r" , strlen("AT$PAC\r"), 1000);
		HAL_Delay( 500 );
		HAL_UART_Transmit( &huart2, "AT$ID\r" , strlen("AT$ID\r"), 1000);
		HAL_Delay( 500 );

	#endif


	#ifdef MURATA
		while(1) {
			uartRxBuffClear();
			HAL_Delay(500);
			HAL_UART_Transmit( &huart2, "\r" , strlen("\r"), 1000);
			HAL_Delay(500);
			HAL_UART_Transmit( &huart2, "AT+DEVEUI?\r" , strlen("AT+DEVEUI?\r"), 1000);
			char buffer_deveui[ 50 ];
			HAL_Delay(5000);
			if ( findMatchAndValueBlockingChar("+OK=", strlen("+OK="), deveui, strlen( "+OK=" ), strlen("3238313962368C05"), 1 ) == 1 ) {
				uint8_t check = 1;

				for ( int x = 0; x < strlen("3238313962368C05"); x++ ) {

					if ( deveui[ x ] > 47 && deveui[ x ] < 91 ) {
						check = 1;
					}else{
						check = 0;
						break;
					}

				}

				if ( check == 1 ) {
					break;
				}
			}
			attempts++;
			if ( attempts > 10 ) {
				return 0;
			}

		}
		attempts = 0;
		while(1)
		{
			uartRxBuffClear();
			HAL_Delay(500);
			HAL_UART_Transmit( &huart2, "\r" , strlen("\r"), 1000);
			HAL_Delay(500);
			HAL_UART_Transmit( &huart2, "AT+DEVADDR?\r" , strlen("AT+DEVADDR?\r"), 1000);
			HAL_Delay(5000);
			if ( findMatchAndValueBlockingChar("+OK=", strlen("+OK="), dev_addr, strlen( "+OK=" ), strlen("1E6162A3"), 1 ) == 1 ) {
				uint8_t check = 1;

				for ( int x = 0; x < strlen("1E6162A3"); x++ ) {

					if ( dev_addr[ x ] > 47 && dev_addr[ x ] < 91 ) {
						check = 1;
					}else{
						check = 0;
						break;
					}

				}

				if ( check == 1 ) {
					break;
				}
			}
			attempts++;
			if ( attempts > 10 ) {
				return 0;
			}

		}

	#endif
		return 1;
}

void checkLed() {

	  HAL_GPIO_WritePin( LED_GPIO_Port, LED_Pin, GPIO_PIN_RESET );
	  HAL_Delay( 1000 );
	  HAL_GPIO_WritePin( LED_GPIO_Port, LED_Pin, GPIO_PIN_SET );
	  HAL_Delay( 1000 );
	  HAL_GPIO_WritePin( LED_GPIO_Port, LED_Pin, GPIO_PIN_RESET );
	  HAL_Delay( 1000 );
	  HAL_GPIO_WritePin( LED_GPIO_Port, LED_Pin, GPIO_PIN_SET );

}

void checkTransmission() {

	  //sendMsg( "SENDING_MSG REPORT" );
/*
	  HAL_GPIO_WritePin( LED_GPIO_Port, LED_Pin, GPIO_PIN_RESET );
	  HAL_Delay( 1000 );
	  HAL_GPIO_WritePin( LED_GPIO_Port, LED_Pin, GPIO_PIN_SET );
	  HAL_Delay( 1000 );
	  HAL_GPIO_WritePin( LED_GPIO_Port, LED_Pin, GPIO_PIN_RESET );
	  HAL_Delay( 1000 );
	  HAL_GPIO_WritePin( LED_GPIO_Port, LED_Pin, GPIO_PIN_SET );
*/


	  sendMsg( "SEND_MSG OK" );

}



int8_t checkRadio() {
	//checkLed();
	//radio_off();
	HAL_Delay( 1000 );

	HAL_Delay( 3000 );

	uartRxBuffClear();
	//radio_off();
	//radio_init_uart();
	//radio_init_uart();

	HAL_GPIO_WritePin( RM_NRST_GPIO_Port, RM_NRST_Pin, GPIO_PIN_RESET );
	HAL_Delay( 1000 );
	HAL_GPIO_WritePin( RM_NRST_GPIO_Port, RM_NRST_Pin, GPIO_PIN_SET );
	HAL_Delay( 1000 );

	#ifdef SIGFOX
		if ( findMatchNonblocking( "SIGFOX", 6, 5000 ) == 0 ) {
			sendMsg( "Report: No response" );
			return -1;
		}
	#endif

	#ifdef MURATA
		if ( findMatchNonblocking( "EVENT", strlen( "EVENT" ), 5000 ) == 0 ) {
			sendMsg( "Report: No response" );
			return -1;
		}
	#endif

		//HAL_Delay(500);
		HAL_UART_Transmit(&huart2, "\r", strlen("\r"), 500);

		HAL_UART_Transmit(&huart2, "AT+FACNEW\r", strlen("AT+FACNEW\r"), 500);
		HAL_Delay(5000);
		HAL_UART_Transmit(&huart2, "AT+CLASS=0\r", strlen("AT+CLASS=0\r"), 500);
		HAL_Delay(500);
		HAL_UART_Transmit(&huart2, "AT+DFORMAT=1\r", strlen("AT+DFORMAT=1\r"), 500);
		HAL_Delay(500);
		HAL_UART_Transmit(&huart2, "AT+ADR=0\r", strlen("AT+ADR=0\r"), 500);
		HAL_Delay(500);
		HAL_UART_Transmit(&huart2, "AT+DR=0\r", strlen("AT+DR=0\r"), 500);
		HAL_Delay(500);
		HAL_UART_Transmit(&huart2, "AT+BAND=5\r", strlen("AT+BAND=5\r"), 500);

		HAL_Delay(500);
	//#define OTA
	#define ABP
	#ifdef OTA
		HAL_UART_Transmit(&huart2, "AT+MODE=1\r", strlen("AT+MODE=1\r"), 500);
	#endif
	#ifdef ABP
		HAL_UART_Transmit(&huart2, "AT+MODE=0\r", strlen("AT+MODE=0\r"), 500);
	#endif

		HAL_Delay(500);
	//	HAL_UART_Transmit(&huart_radio, "AT+RFPOWER=1,0\r", strlen("AT+RFPOWER=1,0\r"), 500); 	//20dBm
	//	HAL_UART_Transmit(&huart_radio, "AT+RFPOWER=0,0\r", strlen("AT+RFPOWER=1,0\r"), 500); 	//16dBm
		HAL_UART_Transmit(&huart2, "AT+MAXEIRP=20\r", strlen("AT+MAXEIRP=20\r"), 500);
		HAL_Delay(500);

		HAL_UART_Transmit(&huart2, "AT+RFPOWER=1,0\r", strlen("AT+RFPOWER=1,0\r"), 500);	//14dBm

		HAL_Delay(500);
		HAL_UART_Transmit(&huart2, "AT+DUTYCYCLE=0\r", strlen("AT+DUTYCYCLE=0\r"), 500);
		HAL_Delay(500);
		HAL_UART_Transmit(&huart2, "AT+SLEEP=0\r", strlen("AT+SLEEP=0\r"), 500);

		HAL_UART_Transmit( &huart2, "AT+NWKSKEY=9087654321AFBECD5647382910DACFEB\r" , strlen("AT+NWKSKEY=9087654321AFBECD5647382910DACFEB\r"), 1000);
		HAL_Delay(500);
		HAL_UART_Transmit( &huart2, "AT+APPSKEY=1029384756AFBECD5647382910DACFEB\r" , strlen("AT+APPSKEY=1029384756AFBECD5647382910DACFEB\r"), 1000);
		HAL_Delay(500);



	if ( findMatchNonblocking( "OK", 2, 12000 ) == 0 ) {
		sendMsg( "Report: Radio not responding to send data command" );
		return -1;
	}
	//radio_init_uart();

	HAL_GPIO_WritePin( RM_NRST_GPIO_Port, RM_NRST_Pin, GPIO_PIN_SET );
	//HAL_UART_Transmit( &huart_radio, "\rAT+CLASS=0\r", strlen( "\rAT+CLASS=0\r" ), 2000 );


	return 1;
}

void checkPowerConsumption() {
	lowPowerMode();
}

uint8_t checkPhoto() {
	sendMsg( "Report: Place the sensor in dark");

	HAL_GPIO_WritePin( PHT_EN_GPIO_Port, PHT_EN_Pin, GPIO_PIN_SET );

	uint64_t start_time = HAL_GetTick();
	uint8_t ok = 0;
	while((start_time  + 8000 ) > HAL_GetTick() ) {
		if ( HAL_GPIO_ReadPin( WKUP1_PHT_GPIO_Port, WKUP1_PHT_Pin ) == GPIO_PIN_RESET ) {
			ok = 1;
			break;
		}
	}

	if ( ok == 0 )
		return ok;

	sendMsg( "Report: Shine light on the sensor" );

	start_time = HAL_GetTick();
	ok = 0;
	while( (start_time  + 8000 ) > HAL_GetTick() ) {
			if ( HAL_GPIO_ReadPin( WKUP1_PHT_GPIO_Port, WKUP1_PHT_Pin ) == GPIO_PIN_SET ) {
				ok = 1;
				break;
			}
	}


	HAL_GPIO_WritePin( PHT_EN_GPIO_Port, PHT_EN_Pin, GPIO_PIN_RESET );

	return ok;
}
