/*
 * LIS3MDL.c
 *
 *  Created on: Jan 23, 2018
 *      Author: pc
 */

#include "LIS3MDL.h"
extern I2C_HandleTypeDef hi2c1;



void lis3mdl_readWhoAmI() {
	uint8_t data[ 10 ];

	lis3mdl_read( &data, 1, LIS3MDL_WHO_AM_I );
}

void getCurrentVal( Mag3110 * gg ) {
	uint8_t data[2];

	lis3mdl_read( &data, 1, 0x28 );
	gg->x = data[0];

	lis3mdl_read( &data, 1, 0x29 );
	gg->x += data[0] << 8;

	lis3mdl_read( &data, 1, 0x2A );
	gg->y = data[0];

	lis3mdl_read( &data, 1, 0x2B );
	gg->y += data[0] << 8;

	lis3mdl_read( &data, 1, 0x2C );
	gg->z = data[0];

	lis3mdl_read( &data, 1, 0x2D );
	gg->z += data[0] << 8;

}

//uint8_t lis3mdl_get_interrupt_status() {
//	if ( HAL_GPIO_ReadPin( MAG_DRDY_GPIO_Port, MAG_DRDY_Pin ) == GPIO_PIN_SET ) {
//		uint8_t data[ 10 ];
//		lsm6dsl_read(&data, 1, 0x31);		//CTRL10_C	pedo on, reset pedo counter
//		return INTERRUPT;
//	}
//	return NO_INTERRUPT;
//}
int16_t lis3mdl_get_temp() {

	MX_I2C1_Init();
	int16_t temp;
	uint8_t data[ 2 ];
	lis3mdl_read( &data, 1, 0x2E );
	temp = data[0];

	lis3mdl_read( &data, 1, 0x2F );
	temp  += data[0] << 8;

	temp = 25 + temp/8;

	HAL_I2C_DeInit(&hi2c1);
	return temp;

}

HAL_StatusTypeDef lis3mdl_basic_config() {

	uint8_t data;

	HAL_Delay( 500 );

	HAL_StatusTypeDef sta;

	//data = 0b111 100 00;
	data = ((mag1_sr & 0b00000111) << 2);
	data = data + 0b11100000;
	sta = lis3mdl_write(&data, 1, 0x20);		//CTRL1

	if ( sta == HAL_ERROR ){
		return sta;
	}

	data = 0b01100000;
	sta = lis3mdl_write(&data, 1, 0x21);		//CTRL2
	if ( sta == HAL_ERROR ){
		return sta;
	}
	data = 0b00000100;
	sta = lis3mdl_write(&data, 1, 0x22);		//CTRL3
	if ( sta == HAL_ERROR ){
		return sta;
	}
	data = 0b00001100;
	sta = lis3mdl_write(&data, 1, 0x23);		//CTRL4
	if ( sta == HAL_ERROR ){
		return sta;
	}
	data = 0b01000000;
	sta = lis3mdl_write(&data, 1, 0x24);		//CTRL5
	if ( sta == HAL_ERROR ){
		return sta;
	}
//	data = 0b11101111;
//	lis3mdl_write(&data, 1, 0x30);		//INT_CFG

//	uint16_t thresh = 1000;
//
//	data = thresh & 0xFF;
//	lis3mdl_write(&data, 1, 0x32);		//
//
//
//	data = (thresh & 0xFF00) >> 8;
//	lis3mdl_write(&data, 1, 0x33);		//


}

HAL_StatusTypeDef lis3mdl_write( uint8_t * data, uint8_t size, uint8_t reg)
{
	HAL_StatusTypeDef status = HAL_I2C_Mem_Write( &hi2c1, LIS3MDL_ADDR, reg, I2C_MEMADD_SIZE_8BIT, data, size, LIS3MDL_I2C_TIMEOUT );
	return status;
 }

HAL_StatusTypeDef lis3mdl_read( uint8_t * data, uint8_t size, uint8_t reg)
{
	HAL_StatusTypeDef status = HAL_I2C_Mem_Read( &hi2c1, LIS3MDL_ADDR, reg, I2C_MEMADD_SIZE_8BIT, data, size, LIS3MDL_I2C_TIMEOUT );
	return status;
}
