#include "MMC34160PJ.h"

void MMC34160PJuploadSettings() {

	HAL_StatusTypeDef stat;
	//uint8_t data = 0b0000 01 10;
	uint8_t data = 0b00000000;
	/*
	data = data + ( (mag2_sr & 0b00000011) << 2 );

	stat = HAL_I2C_Mem_Write( &hi2c1, 96, 0x07, 1, &data, 1, 1000 );

	if ( stat != HAL_OK ) {
		asm( "nop" );
	}
	*/
	data = 0b00000000;

	stat = HAL_I2C_Mem_Write( &hi2c1, 96, 0x08, 1, &data, 1, 1000 );
	if ( stat != HAL_OK ) {
			asm( "nop" );
	}



}


void setNewMeas() {
	uint8_t val;
	val = 0b00000001;
	HAL_I2C_Mem_Write( &hi2c1, 96, 0x07, 1, &val, 1, 1000 );
}

uint8_t isMeasDone() {
	uint8_t done;

	HAL_I2C_Mem_Read( &hi2c1, 96, 0x06, 1, &done, 1, 1000 );

	return done & 0b00000001;
}

uint8_t MMC34160PJCalculateOffset() {
	uint8_t val = 0b10000000;

	// RESET
	//charge
	HAL_I2C_Mem_Write( &hi2c1, 96, 0x07, 1, &val, 1, 1000 );

	uint8_t charge_pump = 0;
	//wait till charging

	uint64_t timeout = HAL_GetTick();
	uint8_t done = 1;
	while( done == 1 ) {
		HAL_I2C_Mem_Read( &hi2c1, 96, 0x06, 1, &done, 1, 1000 );
		done = (done & 0b00000010) >> 1;
		if ( ( timeout + 5000 ) < HAL_GetTick() ) {
			return 1;
		}
	}

	val = 0b01000000;

	//Yamato ute!
	HAL_I2C_Mem_Write( &hi2c1, 96, 0x07, 1, &val, 1, 1000 );

	HAL_Delay( 10 );

	//MEAS1
	val = 0b00000001;
	HAL_I2C_Mem_Write( &hi2c1, 96, 0x07, 1, &val, 1, 1000 );



	//TO_DO timeout!

	timeout = HAL_GetTick();
	done = 0;
	while( done == 0 ) {
		HAL_I2C_Mem_Read( &hi2c1, 96, 0x06, 1, &done, 1, 1000 );
		done = done & 0b00000001;
		if ( ( timeout + 5000 ) < HAL_GetTick() ) {
			return 1;
		}
	}

	Mag3110 data_set;
	data_set.x = 0;
	data_set.y = 0;
	data_set.z = 0;

	MMC34160PJgetDataRaw( &data_set );

	// RESET
	//charge
	val = 0b10000000;
	HAL_I2C_Mem_Write( &hi2c1, 96, 0x07, 1, &val, 1, 1000 );

	charge_pump = 0;
	//wait till charging

	timeout = HAL_GetTick();
	done = 1;
	while( done == 1 ) {
		HAL_I2C_Mem_Read( &hi2c1, 96, 0x06, 1, &done, 1, 1000 );
		done = (done & 0b00000010) >> 1;
		if ( ( timeout + 5000 ) < HAL_GetTick() ) {
			return 1;
		}
	}

	val = 0b00100000;

	//Yamato ute!
	HAL_I2C_Mem_Write( &hi2c1, 96, 0x07, 1, &val, 1, 1000 );

	HAL_Delay( 10 );

	//MEAS1
	val = 0b00000001;
	HAL_I2C_Mem_Write( &hi2c1, 96, 0x07, 1, &val, 1, 1000 );

	done = 0;

	timeout = HAL_GetTick();

	//TO_DO timeout!
	while( done == 0 ) {
		HAL_I2C_Mem_Read( &hi2c1, 96, 0x06, 1, &done, 1, 1000 );
		done = done & 0b00000001;

		if ( ( timeout + 5000 ) < HAL_GetTick() ) {
			return 1;
		}

	}

	Mag3110 data_reset;
	data_reset.x = 0;
	data_reset.y = 0;
	data_reset.z = 0;

	MMC34160PJgetDataRaw( &data_reset );

	MMC34160PJ_offset.x = ( data_reset.x + data_set.x )/2;
	MMC34160PJ_offset.y = ( data_reset.y + data_set.y )/2;
 	MMC34160PJ_offset.z = ( data_reset.z + data_set.z )/2;
/*
 	char buffer12[ 50 ];

 	sprintf( buffer12, "%d %d %d\n", MMC34160PJ_offset.x, MMC34160PJ_offset.y, MMC34160PJ_offset.z );

 	HAL_UART_Transmit( &huart2, buffer12, strlen( buffer12 ), 1000 );
*/
 	//send_msg_baseline_offset( 0, MMC34160PJ_offset.x, MMC34160PJ_offset.y, MMC34160PJ_offset.z );
 	return 0;
}

void MMC34160PJdemagnatize() {
	uint8_t val = 0b10000000;

	//charge
	HAL_I2C_Mem_Write( &hi2c1, 96, 0x07, 1, &val, 1, 1000 );

	uint8_t charge_pump = 0;
	//wait till charging
	HAL_Delay( 300 );
	val = 0b01000000;

	//Yamato ute!
	HAL_I2C_Mem_Write( &hi2c1, 96, 0x07, 1, &val, 1, 1000 );

}


uint8_t MMC34160PJgetDataRaw( Mag3110 * gg ) {

	uint16_t x = 0,y = 0,z = 0;
	uint8_t val;

	if ( HAL_I2C_Mem_Read( &hi2c1, 96, 0x07, 1, &val, 1, 1000 ) != HAL_OK ) {
		return 0;
	}


	char datas[ 10 ];


	for ( int x = 0; x < 10; x++ ) {
		datas[ x ] = 0;
	}

	if ( HAL_I2C_Mem_Read( &hi2c1, 96, 0, 1, datas, 8, 1000 ) != HAL_OK ) {
		return 0;
	}

	x = datas[0];
	x += (datas[1] << 8);
	y = datas[2];
	y += (datas[3] << 8);
	z = datas[4];
	z += (datas[5] << 8);

	gg->x = ((int16_t)x - 32768.0);
	gg->y = ((int16_t)y - 32768.0);
	gg->z = ((int16_t)z - 32768.0);

/*
	HAL_I2C_Mem_Read( &hi2c1, 96, 0, 1, &val, 1, 1000 );
	x = val;
	HAL_I2C_Mem_Read( &hi2c1, 96, 1, 1, &val, 1, 1000 );
	x += (val << 8);


	HAL_I2C_Mem_Read( &hi2c1, 96, 2, 1, &val, 1, 1000 );
	y = val;
	HAL_I2C_Mem_Read( &hi2c1, 96, 3, 1, &val, 1, 1000 );
	y += (val << 8);

	HAL_I2C_Mem_Read( &hi2c1, 96, 4, 1, &val, 1, 1000 );
	z = val;
	HAL_I2C_Mem_Read( &hi2c1, 96, 5, 1, &val, 1, 1000 );
	z += (val << 8);
*/

/*
	gg->x = x;
	gg->y = y;
	gg->z = z;
*/
	return 1;
}

uint8_t MMC34160PJgetData( Mag3110 * gg ) {

	uint16_t x = 0,y = 0,z = 0;
	uint8_t val;

	if ( HAL_I2C_Mem_Read( &hi2c1, 96, 0x07, 1, &val, 1, 1000 ) != HAL_OK ) {
		return 0;
	}


	char datas[ 10 ];


	for ( int x = 0; x < 10; x++ ) {
		datas[ x ] = 0;
	}

	if ( HAL_I2C_Mem_Read( &hi2c1, 96, 0, 1, datas, 8, 1000 ) != HAL_OK ) {
		return 0;
	}

	x = datas[0];
	x += (datas[1] << 8);
	y = datas[2];
	y += (datas[3] << 8);
	z = datas[4];
	z += (datas[5] << 8);

	gg->x = ((int16_t)x - 32768.0);
	gg->y = ((int16_t)y - 32768.0);
	gg->z = ((int16_t)z - 32768.0);

/*
	HAL_I2C_Mem_Read( &hi2c1, 96, 0, 1, &val, 1, 1000 );
	x = val;
	HAL_I2C_Mem_Read( &hi2c1, 96, 1, 1, &val, 1, 1000 );
	x += (val << 8);


	HAL_I2C_Mem_Read( &hi2c1, 96, 2, 1, &val, 1, 1000 );
	y = val;
	HAL_I2C_Mem_Read( &hi2c1, 96, 3, 1, &val, 1, 1000 );
	y += (val << 8);

	HAL_I2C_Mem_Read( &hi2c1, 96, 4, 1, &val, 1, 1000 );
	z = val;
	HAL_I2C_Mem_Read( &hi2c1, 96, 5, 1, &val, 1, 1000 );
	z += (val << 8);
*/
	if ( use_temp_offset_calc == 1 ) {
		gg->x = gg->x - MMC34160PJ_offset.x;
		gg->y = gg->y - MMC34160PJ_offset.y;
		gg->z = gg->z - MMC34160PJ_offset.z;
	}

/*
	gg->x = x;
	gg->y = y;
	gg->z = z;
*/
	return 1;
}
