#include "NRF24.h"

void nRF24Emit( uint8_t * write_addr, char * buf ) {


	NRF24L01_OpenWritingPipe( write_addr );


	NRF24L01_SetCrcLength( NRF24L01_CRC_16 );
	NRF24L01_Transmit_Status_t status = NRF24L01_Transmit( buf );
    //nRF24initFWUpgrade(1);
}

void startNRFReceiveMode( uint8_t receive_type ) {

	HAL_GPIO_WritePin(BOOST_EN_Port, BOOST_EN_Pin, GPIO_PIN_SET);
	HAL_Delay( 10 );
	HAL_GPIO_WritePin(SPI_EN_Port, SPI_EN_Pin, GPIO_PIN_SET);

	flashActive();
	SystemClock_Config1();
	HAL_GPIO_WritePin( NRF_CSN_Port, NRF_CSN_Pin, GPIO_PIN_RESET );
	HAL_GPIO_WritePin( NRF_CE_Port, NRF_CE_Pin, GPIO_PIN_RESET );
	flashDisable();
	HAL_Delay( 10 );
	MX_SPI1_Init();
	HAL_Delay( 10 );
	HAL_IWDG_Refresh( &hiwdg );
	NRF24L01_Struct1.pins.CE.GPIOx = NRF_CE_Port;
	NRF24L01_Struct1.pins.CE.GPIO_Pin = NRF_CE_Pin;

	NRF24L01_Struct1.pins.CSN.GPIOx = NRF_CSN_Port;								// Declara pinos especificos da spi
	NRF24L01_Struct1.pins.CSN.GPIO_Pin = NRF_CSN_Pin;

	NRF24L01_Struct1.pins.IRQ.GPIOx = NRF_IRQ_Port;									// Interrupt pin is not used yet
	NRF24L01_Struct1.pins.IRQ.GPIO_Pin = NRF_IRQ_Pin;

	NRF24L01_Struct1.pins.PWRS.GPIOx = GPIOA;									// Interrupt pin is not used yet
	NRF24L01_Struct1.pins.PWRS.GPIO_Pin = GPIO_PIN_6;

	NRF24L01_Struct1.pins.MISO.GPIOx = GPIOA;
	NRF24L01_Struct1.pins.MISO.GPIO_Pin = GPIO_PIN_6;
	NRF24L01_Struct1.pins.MOSI.GPIOx = GPIOA;
	NRF24L01_Struct1.pins.MOSI.GPIO_Pin = GPIO_PIN_7;
	NRF24L01_Struct1.pins.SCK.GPIOx = GPIOA;
	NRF24L01_Struct1.pins.SCK.GPIO_Pin = GPIO_PIN_5;

    GPIO_InitTypeDef GPIO_InitStruct;

    GPIO_InitStruct.Pin = GPIO_PIN_0;
    GPIO_InitStruct.Mode = GPIO_MODE_IT_FALLING;
    GPIO_InitStruct.Pull = GPIO_NOPULL;
    GPIO_InitStruct.Speed = GPIO_SPEED_FREQ_VERY_HIGH;
    HAL_GPIO_Init(NRF24L01_Struct1.pins.IRQ.GPIOx, &GPIO_InitStruct);



	uint8_t pipe00_reading_address[ 8 ];
	uint8_t channel = 1;
	// Channel(decimal)
	uint8_t payload = 8;

	if ( receive_type == RECEIVE_COMMANDS ) {
		payload = 32;
	}else if ( receive_type == RECEIVE_BOOTLOADER ) {
		payload = 32;
	}



	NRF24L01_Init( channel, payload, &hspi1, (uint8_t *)&pipe00_reading_address );			//REVER
	NRF24L01_CE_LOW(  );
	NRF24L01_CSN_HIGH(   );

	/* Initialize NRF24L01 on channel 80 and n bytes of payload */
	/* By default 2Mbps data rate and 0dBm output power */

	/* Set 2MBps data rate and -18dBm output power */


	if ( receive_type == RECEIVE_COMMANDS ) {
		NRF24L01_SetRF( NRF24L01_DataRate_1M, NRF24L01_OutputPower_0dBm );
	}else if ( receive_type == RECEIVE_BOOTLOADER ) {
		NRF24L01_SetRF( NRF24L01_DataRate_1M, NRF24L01_OutputPower_0dBm );
	}else if ( receive_type == RECEIVE_RESIDENTIAL_PARKING ) {
		NRF24L01_SetRF( NRF24L01_DataRate_1M, NRF24L01_OutputPower_0dBm );
	}else{
		NRF24L01_SetRF( NRF24L01_DataRate_2M, NRF24L01_OutputPower_0dBm );
	}



	NRF24L01_SetRetries( 0, 0 );

	/* Enable auto acknolodgment */
	//NRF24L01_SetAutoAck(0xFF, 0);									// 0xFF Enable all or if you want enable just pipe 3, insert 3
																								// Have some troble with ack enable... many lost packages

	/* Enable CRC 2bytes */
	NRF24L01_SetCrcLength( NRF24L01_CRC_16 );

	NRF24L01_SetAutoAck( 0xFF, 1 );

	uint8_t resp = NRF24L01_SanityCheck( );

	//NRF24_SetRX( (uint8_t *)&pipe00_reading_address );
	HAL_IWDG_Refresh( &hiwdg );
	uint8_t write_addr[ 5 ];
	if ( receive_type == RECEIVE_COMMANDS ) {
		write_addr[ 0 ] = 0xAD;
		write_addr[ 1 ] = 0xAD;
		write_addr[ 2 ] = 0xAD;
		write_addr[ 3 ] = 0xAD;
		write_addr[ 4 ] = 0xAD;
	}else if ( receive_type == RECEIVE_BOOTLOADER ) {
		write_addr[ 0 ] = 0xAA;
		write_addr[ 1 ] = 0xAA;
		write_addr[ 2 ] = 0xAA;
		write_addr[ 3 ] = 0xAA;
		write_addr[ 4 ] = 0xAA;
	}else if ( receive_type == RECEIVE_NEIGHBOUR_BOUNCE ) {
		write_addr[ 0 ] = 0xAC;
		write_addr[ 1 ] = 0xAC;
		write_addr[ 2 ] = 0xAC;
		write_addr[ 3 ] = 0xAC;
		write_addr[ 4 ] = 0xAC;
	}else if ( receive_type == RECEIVE_RESIDENTIAL_PARKING ) {
		write_addr[ 0 ] = 0xE7;
		write_addr[ 1 ] = 0xE7;
		write_addr[ 2 ] = 0xE7;
		write_addr[ 3 ] = 0xE7;
		write_addr[ 4 ] = 0xE7;
	}else if ( receive_type == RECEIVE_LAID_BOOTLOADER ) {
		write_addr[ 0 ] = 0xAB;
		write_addr[ 1 ] = 0xAB;
		write_addr[ 2 ] = 0xAB;
		write_addr[ 3 ] = 0xAB;
		write_addr[ 4 ] = 0xAB;
	}

	NRF24L01_OpenReadingPipe( 1, write_addr, &pipe00_reading_address );

	if ( receive_type == RECEIVE_RESIDENTIAL_PARKING ) {
		// for compatibility with NRF52
		NRF24L01_WriteRegister( 0x1C, 0x03 );
		NRF24L01_WriteRegister( 0x1D, 0x06 );
	}



	//NRF24L01_OpenWritingPipe( pipeOut1 );

	HAL_Delay(1);

	NRF24L01_StartListening( );

	HAL_Delay(1);
}

void nrf24EmitData(  uint8_t addr_type, uint8_t * buffer, uint64_t duration ) {
	uint8_t write_addr1[ 5 ];

	if ( addr_type == EMIT_COMMANDS ) {

		write_addr1[ 0 ] = 0xAD;
		write_addr1[ 1 ] = 0xAD;
		write_addr1[ 2 ] = 0xAD;
		write_addr1[ 3 ] = 0xAD;
		write_addr1[ 4 ] = 0xAD;
	}

	uint64_t start_time  = HAL_GetTick();

	while( ( start_time + duration ) > HAL_GetTick() ) {
		HAL_IWDG_Refresh( &hiwdg );
		nRF24Emit( &write_addr1, buffer );
	}


}

void nRF24RequestIRFlash() {
	char buf[ 35 ];
	buf[0] = 0xAA;
	buf[1] = 0xAB;
	for( uint8_t x = 0; x < 8; x++ )
		buf[ 2 + x ] = 0;
	buf[ 10 ] = NRF_COMMAND_FLASH_LED;
	buf[ 11 ] = 0x00;

	emitData( EMIT_COMMANDS, buf, COMMAND_RESPONSE_TIME );
}

void nRF24PingSurrounding() {
	char buf[ 35 ];
	buf[0] = 0xAA;
	buf[1] = 0xAB;
	for( uint8_t x = 0; x < 8; x++ )
		buf[ 2 + x ] = 0;
	buf[ 10 ] = NRF_COMMAND_ANSWER_PING;
	buf[ 11 ] = 0x00;

	emitData( EMIT_COMMANDS, buf, COMMAND_RESPONSE_TIME );
}


uint8_t nRF24ServiceResidentialParking() {
	uint8_t n = 1;
	char buffer1[32];
	if ( !HAL_GPIO_ReadPin( NRF_IRQ_Port, NRF_IRQ_Pin )  )
		n = 0;

	if( !n ) {
		HAL_IWDG_Refresh( &hiwdg );
		uint8_t status = NRF24L01_ReadRegister( 0x07 );
		n = 1;

		status = status & 0b00001110;
		status = status >> 1;
		char buf[ 32 ];
		NRF24L01_GetData(&buffer1);
		if (buffer1[ 0 ] == 0xAA && buffer1[ 1 ] == 0xAB ) {
			return buffer1[ 3 ];
		}
		HAL_IWDG_Refresh( &hiwdg );

	}
	return 0;
}


uint8_t nRF24CommandStep() {
	uint8_t resp = 0;

	//resp = nRF24ServiceCommands();

	return resp;
}

uint32_t receiveBounce( uint32_t time ) {
	uint8_t n = 1;
	uint8_t buffer1[ 32 ];
	HAL_IWDG_Refresh( &hiwdg );
	uint64_t start_time = HAL_GetTick();
	uint32_t count = 0;
	while( ( time + start_time ) > HAL_GetTick() ) {
			if ( !HAL_GPIO_ReadPin( NRF_IRQ_Port, NRF_IRQ_Pin )  )
				n = 0;
			if ( NRF24L01_SanityCheck() == 0 ) {
					HAL_SPI_DeInit( &hspi1 );
					HAL_GPIO_WritePin(BOOST_EN_Port, BOOST_EN_Pin, GPIO_PIN_RESET);
					HAL_GPIO_WritePin(SPI_EN_Port, SPI_EN_Pin, GPIO_PIN_RESET);
					flashActive();
					HAL_GPIO_WritePin( NRF_CSN_Port, NRF_CSN_Pin, GPIO_PIN_RESET );
					HAL_GPIO_WritePin( NRF_CE_Port, NRF_CE_Pin, GPIO_PIN_RESET );
					HAL_Delay( 500 );
					startNRFReceiveMode( RECEIVE_BOOTLOADER );
			}
			if( !n ) {


					HAL_IWDG_Refresh( &hiwdg );
					while(1) {
						uint8_t status = NRF24L01_ReadRegister( 0x07 );
						n = 1;



						status = status & 0b00001110;
						status = status >> 1;

						if ( status == 0b111 )
							break;
						char buf[ 32 ];



						NRF24L01_GetData(&buffer1);

						count++;


				   }
			}
	}
	return count;
}


void nRF24bounce( uint32_t n_bounce ) {

	SystemClock_Config1();
	startNRFReceiveMode( RECEIVE_COMMANDS );

    char buf[ 30 ];

    for ( int x = 0; x < 30; x++ ) {
    	buf[ x ] = 0;
    }

    buf[ 0 ] = 1;
    buf[ 1 ] = 2;
    buf[ 2 ] = 3;
    buf[ 3 ] = NRF_POWER;

	while(1) {
		nRF24Emit( 10, buf );
		HAL_IWDG_Refresh( &hiwdg );
	}

	HAL_SPI_DeInit( &hspi1 );

	GPIO_InitTypeDef GPIO_InitStruct;

	GPIO_InitStruct.Pin = GPIO_PIN_6|GPIO_PIN_5|GPIO_PIN_7;
	GPIO_InitStruct.Mode = GPIO_MODE_OUTPUT_PP;
	GPIO_InitStruct.Pull = GPIO_NOPULL;
	GPIO_InitStruct.Speed = GPIO_SPEED_FREQ_LOW;
	HAL_GPIO_Init(GPIOA, &GPIO_InitStruct);

	HAL_GPIO_WritePin( GPIOA, GPIO_PIN_6, GPIO_PIN_RESET );
	HAL_GPIO_WritePin( GPIOA, GPIO_PIN_5, GPIO_PIN_RESET );
	HAL_GPIO_WritePin( GPIOA, GPIO_PIN_7, GPIO_PIN_RESET );

	HAL_GPIO_WritePin( NRF_CSN_Port, NRF_CSN_Pin, GPIO_PIN_RESET );
	HAL_GPIO_WritePin( NRF_CE_Port, NRF_CE_Pin, GPIO_PIN_RESET );
	HAL_GPIO_WritePin(SPI_EN_Port, SPI_EN_Pin, GPIO_PIN_RESET);
	HAL_GPIO_WritePin(BOOST_EN_Port, BOOST_EN_Pin, GPIO_PIN_RESET);
	//SystemClock_Config();

}


void nRF24off() {
	HAL_GPIO_WritePin(NRF24L01_Struct1.pins.PWRS.GPIOx, NRF24L01_Struct1.pins.PWRS.GPIO_Pin, GPIO_PIN_RESET);
}
uint8_t checkIncRegister() {
	uint8_t nn = NRF24L01_DataReady();
 	if( nn == 1 ) {

 		return READY_DATA;
 	}else{
 		return NO_DATA;
 	}
}

void nRF24SendData( uint8_t * data ) {

	uint8_t write_addr1[ 5 ];

	write_addr1[ 0 ] = 0xAA;
	write_addr1[ 1 ] = 0xAA;
	write_addr1[ 2 ] = 0xAA;
	write_addr1[ 3 ] = 0xAA;
	write_addr1[ 4 ] = 0xAA;

	NRF24L01_OpenWritingPipe( write_addr1 );


	NRF24L01_SetCrcLength( NRF24L01_CRC_16 );

	NRF24L01_Transmit_Status_t status = NRF24L01_Transmit( data );

	if ( status == NRF24L01_Transmit_Status_Ok ) {
		//NRF24_remove_command( dev, new_command );
		return 1;
	}else if ( status == NRF24L01_Transmit_Status_Lost ) {
		return 2;
	}
}


uint8_t checkIncomming() {
	uint8_t res = NO_DATA;
#ifdef USE_NRF24_IRQ
	res = checkIncomingPin();
#else
	res = checkIncRegister();
#endif
	return res;

}


void useNRFBounce() {

			HAL_GPIO_WritePin(BOOST_EN_Port, BOOST_EN_Pin, GPIO_PIN_SET);
			HAL_Delay( 500 );
			HAL_GPIO_WritePin(SPI_EN_Port, SPI_EN_Pin, GPIO_PIN_SET);

			HAL_GPIO_DeInit( GPIOA, GPIO_PIN_6 );
			HAL_GPIO_DeInit( GPIOA, GPIO_PIN_5 );
			HAL_GPIO_DeInit( GPIOA, GPIO_PIN_7 );
			flashActive();

			HAL_GPIO_WritePin( NRF_CSN_Port, NRF_CSN_Pin, GPIO_PIN_RESET );
			HAL_GPIO_WritePin( NRF_CE_Port, NRF_CE_Pin, GPIO_PIN_RESET );
			flashDisable();
			HAL_Delay( 500 );
			MX_SPI1_Init();
			HAL_Delay( 100 );
			//flashChipErase();

			startNRFReceiveMode( RECEIVE_COMMANDS );
			char buff[ 32 ];
			for( int x = 0; x < 32; x++ )
				buff[ x ] = 0;

		    for( int x = 0; x < 20; x++ ) {


				uint8_t write_addr1[ 5 ];

				write_addr1[ 0 ] = 0xAA;
				write_addr1[ 1 ] = 0xAA;
				write_addr1[ 2 ] = 0xAA;
				write_addr1[ 3 ] = 0xAA;
				write_addr1[ 4 ] = 0xAA;

				NRF24L01_OpenWritingPipe( write_addr1 );


				NRF24L01_SetCrcLength( NRF24L01_CRC_16 );
				NRF24L01_Transmit_Status_t status = NRF24L01_Transmit( &buff );

		    }
		    stopNRFMode();
}
