/*
 * NeigbourParking.c
 *
 *  Created on: Jun 4, 2019
 *      Author: Tomas
 */


#include "NeigbourParking.h"

void nbPutNewNeighbour( char * buffer )
{

	for ( uint8_t x = 0; x < 8; x++ ) {
		neighbours[ number_of_neighbours ][ x ] = buffer[ x ];
	}

	number_of_neighbours++;

}

void nbCreateStructure( NBDetection * nb_detection )
{

	nb_detection->bellum = 0;
	nb_detection->stable_a = 0;
	nb_detection->overshoot_count = 0;
	nb_detection->last_check_tick_count = 0;
	nb_detection->current_tick_count = 0;

}

void nbInit()
{

	number_of_neighbours = 0;

}

uint8_t nbNRFInit() {
	startNRFReceiveMode( RECEIVE_NEIGHBOUR_BOUNCE );
}

void nbStep( parking_tomas_t * t ) {

	uint8_t check_surroundings = 0;

	if ( t->state == 2 ) {
		nb_detection.bellum = t->bellum;
	}

	if ( t->diff*t->diff > NB_SEARCH_THRESHOLD*NB_SEARCH_THRESHOLD ) {
		check_surroundings = 1;
		nb_detection.overshoot_count += 1;

	}

	if ( t->diff*t->diff < NB_SEARCH_THRESHOLD*NB_SEARCH_THRESHOLD ) {

		nb_detection.overshoot_count = 0;

	}

	if ( ( nb_detection.current_tick_count ) < NB_CHECK_TIMEOUT) {

		 check_surroundings = 0;
	}


	if ( check_surroundings == 1 && nb_detection.overshoot_count > 5 ) {

		nbNRFInit();

		uint64_t start_time = HAL_GetTick();
		nb_detection.overshoot_count = 0;
		while( ( start_time + NRF_NEIGHBOUR_SEARCH_TIME ) > HAL_GetTick() ) {
			if ( isPacketWaiting() == 1 ) {

				char buffer[ 32 ];
				getPacket( buffer );

				if ( buffer[ 0 ] == 0xAA && buffer[1] == 0xAB  && buffer[3] == 0x02 ) {
					if ( nbCheckIfNeighbourInNeighbours( buffer + 4 ) == 1 ) {

						break;

					}
				}

			}
		}

		nbNRFDeinit();
		nb_detection.current_tick_count = 0;
	}


}

void nbNRFDeinit() {

	stopNRFMode();

}

uint8_t nbCheckIfNeighbourInNeighbours( char * buffer )
{

	for ( uint8_t x = 0; x < number_of_neighbours; x++ ) {
		uint8_t found = 0;

		for ( uint8_t y = 0; y < 8; y++ ) {

			if ( neighbours[ x ][ y ] == buffer[ y ] ) {
				found = 1;
			}else{
				found = 0;
				break;
			}

		}

		if ( found == 1 ) {
			return 1;
		}

	}

	return 0;
}
