/*
 * SPIFlash.c
 *
 *  Created on: Oct 31, 2018
 *      Author: Tomas
 */


#include "SPIFlash.h"

void flashOn() {

	//HAL_GPIO_WritePin( NRF_FLASH_EN_Port, NRF_FLASH_EN_Pin, ENABLE );
	HAL_Delay( 500 );
}

void flashOff() {
	//HAL_GPIO_WritePin( NRF_FLASH_EN_Port, NRF_FLASH_EN_Pin, DISABLE );
}

void flashReadID( uint8_t * response_container ) {
	flashActive();
	HAL_Delay( 1 );

	uint8_t data[ 4 ];
	data[0] = FLASH_OP_READ_ID;
	data[1] = 0;
	data[2] = 0;
	data[3] = 0;
	if ( HAL_SPI_TransmitReceive( &hspi1, data,response_container, 3, 500 ) != HAL_OK ) {
		asm( "nop" );
	}

	flashDisable();
}

void flashReadData( uint8_t * recv_buffer, uint16_t length, uint32_t addr ) {
	flashActive();
	uint8_t data[512];
	data[0] = FLASH_OP_READ_MEMORY;
	data[1] = (addr >> 16) & 0xFF;
	data[2] = (addr >> 8) & 0xFF;
	data[3] = (addr) & 0xFF;

	uint8_t recv_buffer1[ 255 ];

	for( int x = 0; x < 255; x++ ) {
		recv_buffer1[ x ] = 0;
	}

	HAL_SPI_TransmitReceive( &hspi1, data, recv_buffer1, 4+length, 5000 );

	for( int x = 0; x < length; x++ ) {
		recv_buffer[ x ] = recv_buffer1[ x + 4 ];
	}



	flashDisable();
}


void flashWriteData( uint8_t * datas, uint16_t length, uint32_t addr ) {

    setWriteEnable();
	flashWaitForCompletion();
	flashActive();
	uint8_t data[ 255 ];
	data[0] = FLASH_OP_WRITE_MEMORY;
	data[1] = (addr >> 16) & 0xFF;
	data[2] = (addr >> 8) & 0xFF;
	data[3] = (addr) & 0xFF;

	for( int x = 0; x < length; x++ ) {
		data[ x+4 ] = datas[ x ];
	}

	HAL_SPI_Transmit( &hspi1, data, 4+length, 500 );

	flashDisable();
	flashWaitForCompletion();
}

int flashWaitForCompletion() {
	uint8_t res[2];

	uint64_t start_time = HAL_GetTick();

	flasReadStatus1( res );
	while( res[1] & 0b00000001 == 1  && (start_time + 200000) > HAL_GetTick() ) {
		flasReadStatus1( &res );
		HAL_IWDG_Refresh( &hiwdg );
	}

	if ( res[1] & 0b00000001 != 1 ) {
		return 1;
	}
	return 0;
}

int setWriteEnable() {
	uint8_t res[2], res1 = 0;
	uint64_t start_time = HAL_GetTick();

	while( res1 == 0 && (start_time + 200000) > HAL_GetTick() ) {
		flashWriteEnable();
		flasReadStatus1( &res );
		res1 = res[1];
		res1 = res1 & 0b00000010;
		res1 = (res1 >> 1);
	}
	if ( res1 != 0 ) {
		return 1;
	}

	return 0;
}

int flashChipErase() {


	setWriteEnable();

	flashActive();
	uint8_t data[ 1 ];
	data[0] = FLASH_OP_CHIP_ERASE;
	HAL_SPI_Transmit( &hspi1, data, 1, 500 );
	flashDisable();

	flashWaitForCompletion();

	return 1;

}

void flashDisable() {
	HAL_GPIO_WritePin( FLASH_CSN_Port, FLASH_CSN_Pin, ENABLE  );
}

void flashActive() {
	HAL_GPIO_WritePin( FLASH_CSN_Port, FLASH_CSN_Pin, DISABLE);
}


void flasReadStatus1( uint8_t * output ) {
	flashActive();

	uint8_t data[ 2 ];
	data[0] = FLASH_OP_READ_STATUS1;
	data[ 1 ] = 0;

	HAL_SPI_TransmitReceive( &hspi1, data, output, 2, 500 );

	flashDisable();
}

void flashWriteEnable() {
	flashActive();

	uint8_t data[ 1 ];
	data[0] = FLASH_OP_WRITE_ENABLE;

	if ( HAL_SPI_Transmit( &hspi1, data, 1, 500 ) != HAL_OK ) {
		asm( "nop" );
	}
	flashDisable();

}
