/*
 * SPIFlash.h
 *
 *  Created on: Oct 31, 2018
 *      Author: Tomas
 */

#ifndef SPIFLASH_H_
#define SPIFLASH_H_

#include "main.h"
#include "gpio.h"
#include "spi.h"
#include "iwdg.h"

#define FLASH_OP_WRITE_ENABLE 0x06
#define FLASH_OP_WRITE_DISABLE 0x04

#define FLASH_OP_CHIP_ERASE 0x60

#define FLASH_OP_WRITE_MEMORY 0x02
#define FLASH_OP_READ_MEMORY 0x03

#define FLASH_OP_READ_ID 0x9F
#define FLASH_OP_READ_STATUS1 0x05
void flashActive();
void flashDisable();

void flashReadID( uint8_t * response_container );
void flashWriteData( uint8_t * datas, uint16_t length, uint32_t addr );
void flashReadData( uint8_t * recv_buffer, uint16_t length, uint32_t addr );
int flashChipErase();
void flasReadStatus1( uint8_t * output );
int setWriteEnable();

#endif /* SPIFLASH_H_ */
