/*
 * X111.h
 *
 *  Created on: Jun 27, 2019
 *      Author: Tomas
 */

#ifndef X111_H_
#define X111_H_

#include "main.h"
#include "spi.h"
#include "iwdg.h"
#include "gpio.h"


#define WRITE_RADAR_DISTANCE_MIN_MAX 1
#define WRITE_RADAR_SWEEP 2
#define WRITE_MIN_AMPLITUDE_FOR_DETECTION 3

#define READ_RESULT 4
#define READ_WHO_AM_I 5
#define FREE_IRQ_PIN 6
#define ASSERT_IRQ_PIN 7



#define SPI_STATE_REG 0
#define SPI_STATE_VAL 1

#define READ_OP 1
#define WRITE_OP 2



extern SPI_HandleTypeDef hspi1;
uint8_t sendRequest( uint8_t type, uint8_t op_code, char * op_buffer, uint8_t op_buffer_size, char * response_buffer );

uint8_t isRadarPresent();
uint8_t radarAssertIRQ();
// min and length are in m*100
uint8_t setMinLength( uint16_t min, uint16_t length );

uint8_t setNewSweep( char * sweep_results );

uint8_t isSweepComplete();

uint8_t getSweepResults( char * buffer );

uint8_t setAmplitudeRange( uint16_t amp );
void getRadarData( char * radar_data );
void buildOp( uint8_t op_type, uint8_t op_code, char * buffer );

#endif /* X111_H_ */
