/*
 * battery.h
 *
 *  Created on: May 2, 2017
 *      Author: fiala
 */

#ifndef BATTERY_H_
#define BATTERY_H_

#include "stm32l0xx_hal.h"
#include "common.h"
#include "main.h"
#include <math.h>
#include <usart.h>

#define BATT_MIN	3.0
#define BATT_MAX	3.8



float batt_measure(void);
uint8_t batt_state(float);
void batt_init(void);
uint32_t readADC(void);
uint32_t batt_get_voltage( void );
float batt_adc_to_voltage(uint32_t adcBAT, uint32_t adcCPU);
void batt_measure_periodic_IT_start( void );
void batt_measure_periodic_IT_stop( void );
void setBatReadPin( uint8_t state );
struct batt_t
{
	uint32_t calib_value;
};


#endif /* BATTERY_H_ */
