/*
 * common.c
 *
 *  Created on: Apr 26, 2017
 *      Author: fiala
 */

#include "common.h"
#include "stm32l0xx_hal.h"


void stuffByte( char * buffer, char * output_buffer ) {
	uint8_t str_buffer_len = strlen( buffer );
	if ( strlen( buffer ) % 2 == 0 ) {
		for( int x = 0; x < str_buffer_len; x++ ) {
			output_buffer[ x ] = buffer[ x ];
		}
		return;
	}
	uint8_t buffer_temp_pos = 1;
	output_buffer[ 0 ] = '0';
	for( int x = 0; x < str_buffer_len; x++ ) {
		output_buffer[ buffer_temp_pos ] = buffer[ x ];
		buffer_temp_pos++;
	}

}

void dataToHex(char * out_string, uint8_t data)
{
	char conv[] = {'0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F'};

	out_string[1] = conv[ (data & 0b00001111) ];
	out_string[0] = conv[ (data & 0b11110000) >> 4 ];
}

void concat(char s1[], char s2[])
{
   int i, j;

   i = strlen(s1);

   for (j = 0; s2[j] != '\0'; i++, j++) {
      s1[i] = s2[j];
   }

   s1[i] = '\0';
}

void blinkLed( uint64_t time ) {
	HAL_GPIO_WritePin(GPIOB, LED_Pin, GPIO_PIN_RESET);
	HAL_Delay( time );
	HAL_GPIO_WritePin(GPIOB, LED_Pin, GPIO_PIN_SET);
	HAL_Delay( time );
}

void get_dec_str (uint8_t * str, size_t len, int16_t val)
{
  uint8_t i;
  if ( val < 0 ) {
	  val = val * ( -1 );
	  str[ 0 ] = '-';
  }else{
	  str[ 0 ] = '+';
  }


  for(i=1; i<=len-1; i++)
  {
    str[len-i] = (uint8_t) ((val % 10UL) + '0');
    val/=10;
  }

  str[i] = ',';
  //str[i+1] = '\n';
  str[i+1] = '\0';

}

uint8_t debounce(GPIO_TypeDef* GPIOx, uint16_t GPIO_Pin)
{
	GPIO_PinState state = HAL_GPIO_ReadPin(GPIOx , GPIO_Pin);
	uint8_t cnt=0;
	while(cnt < 100)
	{
		GPIO_PinState new_state = HAL_GPIO_ReadPin(GPIOx , GPIO_Pin);
		if(state == new_state)
			cnt ++;
		else
			cnt = 0;
		state = new_state;
	}
	return state;
}

int32_t strToDec(uint8_t * str, uint8_t str_len)
{
	int32_t dec = 0;
	for(uint8_t i = 0; i<str_len; i++)
	{
		dec = dec * 10 + ( str[i] - '0' );
	}

	return dec;
}
/*
float atan2(float x, float y)
{	// calculates atan2, returns: angle in deg, range < 0 ; 360 ), max error 0.162 deg
	if(x <  0 && y == 0)   	return 270.0;
    if(x >  0 && y == 0)   	return 90.0;
    if(x == 0 && y == 0)    return (-1.0);//error condition
    if(x == 0 && y >  0)    return 0.0;
    if(x == 0 && y <  0)    return 180.0;

    ///arctan aproximation
    float fi = fabs( x / y );
    float fi2 = fi * fi;
    fi = ((0.596227 * fi + fi2) / (1.0 + 2.0 * 0.596227 * fi + fi2 )) * 90.0;

    /// cover all quadrants
    if(x >= 0 && y > 0)   	return (fi);
    if(x < 0 && y > 0)    	return (360.0 - fi);
    if(x >= 0 && y < 0)   	return (180.0 - fi);
    if(x < 0 && y < 0)    	return (fi + 180.0);
//  if(x < 0 and y == 0)   	return (fi - 180.0);
    return (-1.0); //error condition
}
*/
