/*
 * murata.c
 *
 *  Created on: Aug 18, 2017
 *      Author: fiala
 */

#include "lora.h"


void lora_UART_Init(void)
{

	HAL_NVIC_SetPriority(DMA1_Channel2_3_IRQn, 0, 0);
	HAL_NVIC_EnableIRQ(DMA1_Channel2_3_IRQn);

	HAL_NVIC_SetPriority(DMA1_Channel4_5_6_7_IRQn, 0, 0);
	HAL_NVIC_EnableIRQ(DMA1_Channel4_5_6_7_IRQn);


	MX_DMA_Init();
	MX_USART2_UART_Init( 19200 );
	MX_USART1_UART_Init();


	uartRxBuffInit();
	uartRxBuff2Init();

	while( HAL_UART_Receive_DMA( &huart2, rxData, 2 ) != HAL_OK)
		continue;

	while( HAL_UART_Receive_DMA( &huart1, rxData2, 20 ) != HAL_OK)
		continue;


}

void write16ToMemory( uint16_t data, uint64_t addr ) {
	uint16_t v = data;

	uint8_t b1 = (v >> 8) & 0xFF;
	uint8_t b2 = (v) & 0xFF;

	nvmWriteByte( addr, b1 );
	nvmWriteByte( addr, b2 );
}

void write8ToMemory( uint8_t data, uint64_t addr ) {

	uint16_t v = data;

	uint8_t b2 = (v) & 0xFF;

	nvmWriteByte( addr, b2 );

}

uint8_t lora_recv_mac() {
/*
	char msg_radio[14] = "\rAT+UTX 1\r62\r\0";


	HAL_UART_Transmit( &huart2, "\r", 1, DEFAULT_UART_TIMEOUT );
	HAL_Delay( 25 );
	HAL_UART_Transmit( &huart2, msg_radio, strlen( msg_radio ), DEFAULT_UART_TIMEOUT );
	uartRxBuffClear();
	*/
	uint64_t start = HAL_GetTick();
	while( start + 7000 > HAL_GetTick() ) {
	uint8_t position = 0;
		if ( findMatchNonblockingPos2( "mac", strlen( "mac" ), 500, &position ) == 1 ) {
			return 1;
		}
	}



	return 0;
}

uint8_t wait_for_recv( char * response_buff ) {
	uint8_t position = 0;

	if ( findMatchNonblockingPos( "+RECV=", 6, 4000, &position ) == 1 ) {
		shiftBufferToPosition( found_match_position );


		uint8_t c = 0;

		char buffer_size[2];

		uartRxBuffRead();
		uartRxBuffRead();
		uartRxBuffRead();
		uartRxBuffRead();
		uartRxBuffRead();
		uartRxBuffRead();
		uartRxBuffRead();
		uartRxBuffRead();

		buffer_size[0] = uartRxBuffRead();
		buffer_size[1] = uartRxBuffRead();
		char *ptr;
		uint16_t total_length = strtol( buffer_size, &ptr, 10 );
		total_length = total_length;

		if ( total_length > 100 )
			return 0;

		uartRxBuffRead();
		uartRxBuffRead();
		uartRxBuffRead();
		uartRxBuffRead();

		while( c < total_length ) {
			buffer_size[0] = uartRxBuffRead();
			buffer_size[1] = uartRxBuffRead();

			char *ptr;

			uint32_t total_length = strtol( buffer_size, &ptr, 16 );

			response_buff[ c ] = (uint8_t)(total_length & 0xFF);
			c++;

		}
		return c;
	}

	if ( findMatchNonblockingPos( "+ACK", 4, 500, &position ) == 1 ) {
		return ACK_COMMAND;
	}

	return 0;
}

uint8_t lora_recv_msg( char * response_buffer ) {
/*
	char msg_radio[14] = "\rAT+UTX 1\r62\r\0";


	HAL_UART_Transmit( &huart2, "\r", 1, DEFAULT_UART_TIMEOUT );
	HAL_Delay( 25 );
	HAL_UART_Transmit( &huart2, msg_radio, strlen( msg_radio ), DEFAULT_UART_TIMEOUT );
	uartRxBuffClear();
	*/
		uint16_t status = response_buffer[0];

		if ( status == RESTART_MSG ) {
			asm( "nop" );
			// perform restart schedule
			/*
			ff[ 0 ] = uartRxBuffRead();
			ff[ 1 ] = uartRxBuffRead();
			ff[ 2 ] = '\0';
			uint8_t in_number_of_hours = strtol( ff, ptr, 16 );
			*/
			uint16_t in_number_of_hours = ( response_buffer[1] << 8 ) + response_buffer[2];

			if ( in_number_of_hours == 0 ) {
				HAL_NVIC_SystemReset();
			}

			//TO_DO staggered restart
			//nvmWriteByte( BASELINE_VAL + 4, 0 );
			return RESTART_REQUEST_COMMAND;
			RTC->BKP0R = 0;
		}else if ( status == SETTINGS_MSG ) {
			asm( "nop" );
			uint16_t ths1 = ( response_buffer[1] << 8 ) + response_buffer[2]; // stop integracii
			//uint16_t ths2 = uartRxReadData( 0, 2 ); // enterring flux
			uint16_t thsUP = ( response_buffer[3] << 8 ) + response_buffer[4]; // r flux
			uint16_t thsDOWN = ( response_buffer[5] << 8 ) + response_buffer[6];  // l value below which unparking is considered with flux

			uint16_t s3_n_counter_threshold = response_buffer[7];
			uint16_t s5_n_counter_threshold = response_buffer[8];
			uint16_t s6_n_counter_threshold = response_buffer[9];

			uint16_t mag_up =  ( response_buffer[10] << 8 ) + response_buffer[11];
			uint16_t mag_down = ( response_buffer[12] << 8 ) + response_buffer[13];

			uint16_t total_up =  ( response_buffer[14] << 8 ) + response_buffer[15];
			uint16_t total_down =  ( response_buffer[16] << 8 ) + response_buffer[17];


			uint16_t rot_up =  ( response_buffer[18] << 8 ) + response_buffer[19];
			uint16_t rot_down =  ( response_buffer[20] << 8 ) + response_buffer[21];


			if ( thsDOWN != NO_CHANGE )
				data_x.threshold_down = thsDOWN;

			if ( thsUP != NO_CHANGE )
				data_x.threshold_up = thsUP;

			if ( ths1 != NO_CHANGE )
				data_x.threshold_intg  = ths1;

			if ( s3_n_counter_threshold != NO_CHANGE )
				data_x.s3_n_counter_threshold = s3_n_counter_threshold;

			if ( s5_n_counter_threshold != NO_CHANGE )
				data_x.s5_n_counter_threshold = s5_n_counter_threshold;

			if ( s6_n_counter_threshold != NO_CHANGE )
				data_x.s6_n_counter_threshold = s6_n_counter_threshold;

			if ( mag_down != NO_CHANGE )
				data_mag.threshold_down = mag_down;

			if ( mag_up != NO_CHANGE )
				data_mag.threshold_up = mag_up;

			if ( total_down != NO_CHANGE )
				data_total.threshold_down = total_down;

			if ( total_up != NO_CHANGE )
				data_total.threshold_up = total_up;

			if ( rot_down != NO_CHANGE )
				data_rotation.threshold_down = rot_down;

			if ( rot_up != NO_CHANGE )
				data_rotation.threshold_up = rot_up;


			return NEW_CONFIG_COMMAND;

		}else if ( status == BASELINE_MSG ) {

			uint16_t soft_reset_threshold1 =  ( response_buffer[1] << 8 ) + response_buffer[2];
			uint16_t soft_reset_threshold2 =  ( response_buffer[3] << 8 ) + response_buffer[4];

			uint16_t hard_reset_threshold1 =  ( response_buffer[5] << 8 ) + response_buffer[6];
			uint16_t hard_reset_threshold2 =  ( response_buffer[7] << 8 ) + response_buffer[8];

			uint16_t use_baseline =  response_buffer[9];

			uint16_t main_counter_threshold = ( response_buffer[10] << 8 ) + response_buffer[11];
			uint16_t warm_up_time = ( response_buffer[12] << 8 ) + response_buffer[13];

			uint16_t buffer_size = response_buffer[14];

			uint16_t total_mag_up =  ( response_buffer[15] << 8 ) + response_buffer[16];
			uint16_t total_mag_down =  ( response_buffer[17] << 8 ) + response_buffer[18];


			int32_t soft_reset_threshold = ( soft_reset_threshold1 << 16 ) + soft_reset_threshold2;

			if ( total_mag_up != NO_CHANGE )
				data_mag_total.threshold_up = total_mag_up;

			if ( total_mag_down != NO_CHANGE )
				data_mag_total.threshold_down = total_mag_down;

			if ( main_counter_threshold != NO_CHANGE )
				data_x.main_counter_threshold = main_counter_threshold;

			if ( warm_up_time != NO_CHANGE )
				data_x.warm_up_time = warm_up_time;

			if ( buffer_size != NO_CHANGE )
				data_x.buffer_size  = buffer_size;

			if ( soft_reset_threshold != 0 ) {
				mag_reset_offset_counter = soft_reset_threshold;

			}

			int32_t hard_reset_threshold = ( hard_reset_threshold1 << 16 ) + hard_reset_threshold2;

			if ( hard_reset_threshold != 0 ) {
				hard_mag_reset_offset_counter = hard_reset_threshold;
			}


			if ( use_baseline != 0 ) {
				using_baseline_integration = use_baseline;
			}


			return NEW_BASELINE_COMMAND;

		}else if ( status == KA_SETTINGS ) {
			uint32_t time = ( response_buffer[1] << 24 ) + ( response_buffer[2] << 16 )  + ( response_buffer[3] << 8 )  + ( response_buffer[4] );
			uint32_t n_of_repetition_msg = response_buffer[5];
			uint8_t transmisson_modes = response_buffer[6];

			uint16_t baseline1 =  ( response_buffer[7] << 8 )  + ( response_buffer[8] );
			uint16_t baseline2 = ( response_buffer[9] << 8 )  + ( response_buffer[10] );

			uint8_t inrsync =  response_buffer[11];
			uint8_t ack_settings = response_buffer[12];
			uint8_t ack_n_settings = response_buffer[13];

			uint32_t residential_mode_time = ( response_buffer[14] << 16 ) + ( response_buffer[15] << 8 ) + response_buffer[16];

			uint32_t interval_for_network_mac_confirmation = ( baseline1 << 16 ) + baseline2;


			if ( residential_mode_time != 0 )
				residential_mode_time_offset = residential_mode_time;

			if ( time != 0 ) {
				max_idle_periods = time/magnetic_constant;
			}

			if ( n_of_repetition_msg != 0 ) {
				number_of_msg_repetition = n_of_repetition_msg;
			}

			if ( interval_for_network_mac_confirmation != 0 ) {
				mac_command_ressend_interval = interval_for_network_mac_confirmation / magnetic_constant;
			}

			ack_msgs = ack_settings;

			if ( ack_n_settings != 0 ) {
				ack_n_timeout = ack_n_settings;
			}

			transmisson_mode = transmisson_modes;

			imidiate_network_resync = inrsync;

			if ( transmisson_mode == 1 ) {
				//max_idle_periods = 300 / magnetic_constant;
			}

			return KA_SETTINGS;
		}else if ( status == OP_SETTINGS ) {

			asm( "nop" );
			uint8_t nrf_modes = response_buffer[1];
			uint16_t pht_ons = response_buffer[2];
			uint16_t nrf_speed = response_buffer[3];
			uint16_t radar_modes = response_buffer[4];
			uint32_t nrf_command_rcv_interval1 = ( response_buffer[5] << 24 ) + ( response_buffer[6] << 16 ) + ( response_buffer[7] << 8 ) + response_buffer[8];
			uint32_t radar_min_amp = ( response_buffer[9] << 8 ) + ( response_buffer[10] ) ;



			if ( nrf_command_rcv_interval1 != 0 )
				nrf_command_rcv_interval = nrf_command_rcv_interval1;

			NRF24_POWER = nrf_speed;

			//int32_t baseline = ( baseline1 << 16 ) + baseline2;

			if ( radar_min_amp != 0 )
				RADAR_MIN_AMPLITUDE = radar_min_amp;

			if ( nrf_modes == NRF_MODE) {
				if ( pht_ons == 1 ) {

					pht_ons_data = 1;
				}
				nrf_startup = 1;
			}

			if ( nrf_mode == NRF_MODE && nrf_modes == NO_NRF_MODE) {
				nrf_startup = 2;

			}

			if ( nrf_mode == NO_NRF_MODE && nrf_modes == NRF_SPEED_TEST_MODE) {
				nrf_startup = 3;

			}

			if ( nrf_mode == NO_NRF_MODE && nrf_modes == NRF_BOUNCE_MODE ) {
				nrf_mode = NRF_BOUNCE_MODE;

			}

			if ( nrf_mode == NO_NRF_MODE && nrf_modes == NRF_COMMAND_MODE ) {
				nrf_startup = 7;

			}

			if ( nrf_mode == NO_NRF_MODE && nrf_modes == NRF_RESIDENTIAL_MODE ) {
				nrf_mode = NRF_RESIDENTIAL_MODE;

			}

			if ( nrf_mode == NRF_COMMAND_MODE && nrf_modes == NO_NRF_MODE ) {
				nrf_startup = 4;

			}

			if ( nrf_mode != NO_NRF_MODE && nrf_modes == NO_NRF_MODE ) {
				nrf_startup = 99;

			}

			if ( nrf_modes == NRF_LAIRD_MODE ) {
				nrf_startup = 10;

			}

			if ( radar_modes != 0 )
				radar_mode = radar_modes;


			return OP_SETTINGS;

		}else if ( status == ID_SETTINGS ) {
			return ID_SETTINGS;

		}else if ( status == VERSION_SETTINGS ) {
			return VERSION_SETTINGS;

		}else if ( status == BASELINE_VALUE ) {
			return BASELINE_VALUE;

		}else if ( status == POINT_VALUES ) {

			int16_t x = ( response_buffer[1] << 8 )  + ( response_buffer[2] );
			int16_t y = ( response_buffer[3] << 8 )  + ( response_buffer[4] );
			int16_t z = ( response_buffer[5] << 8 )  + ( response_buffer[6] );

			int32_t y_l = y;
			int32_t z_l = z;
			int32_t x_l = x;


			uint32_t vals = ( sqrt( (y_l*y_l) + (z_l*z_l) ) );

			float vals1 = atan2( abs( y_l ), abs( z_l ) );
			vals1 = (vals1) * 1000;

			int32_t vals2 = (vals1);
			int32_t vals3 = atan2( vals , x_l ) * 1000;

			int32_t vals4 =  ( sqrt(  (x_l*x_l) +(y_l*y_l) + (z_l*z_l) ) );


			data_x.bellum = x_l;
			data_x.b_old = x_l;

			data_mag.bellum = vals;
			data_mag.b_old = vals;

			data_rotation.bellum = vals2;
			data_rotation.b_old = vals2;

			data_total.bellum = vals3;
			data_total.b_old = vals3;

			data_mag_total.bellum = vals4;
			data_mag_total.b_old = vals4;

			return POINT_VALUES;

		}else if ( status == POINT_VALUES_BASE ) {

			int16_t data_x1 = ( response_buffer[1] << 8 )  + ( response_buffer[2] );
			int16_t data_rot1 = ( response_buffer[3] << 8 )  + ( response_buffer[4] );
			int16_t data_mag1 = ( response_buffer[5] << 8 )  + ( response_buffer[6] );
			int16_t data_total1 = ( response_buffer[7] << 8 )  + ( response_buffer[8] );
			int16_t data_mag_total1 = ( response_buffer[9] << 8 )  + ( response_buffer[10] );

			if ( data_x1 != 0 ) {
				data_x.bellum = data_x1;
				data_x.b_old = data_x1;
			}

			if ( data_mag1 != 0 ) {

				data_mag.bellum = data_mag1;
				data_mag.b_old = data_mag1;
			}
			if ( data_rot1 != 0 ) {

				data_rotation.bellum = data_rot1;
				data_rotation.b_old = data_rot1;
			}
			if ( data_total1 != 0 ) {

				data_total.bellum = data_total1;
				data_total.b_old = data_total1;
			}
			if ( data_mag_total1 != 0 ) {

				data_mag_total.bellum = data_mag_total1;
				data_mag_total.b_old = data_mag_total1;
			}


			return POINT_VALUES_BASE;

		}else{
			asm( "nop" );


		}


	return NO_COMMAND;
}

#ifdef MURATA
void lora_send_mac_commands() {
	radio_on();

	uint8_t msg_mac_response_count = 0;

    while ( msg_mac_response_count < MAC_RESPONSE_CMD_COUNT ) {

		commandDelay(5000);
	    HAL_IWDG_Refresh( &hiwdg );
		radio_send_msg( "61" );
		msg_mac_response_count++;

    }
    radio_off();
}
#endif

uint8_t lora_on( void )
{
	lora_UART_Init();

	HAL_GPIO_WritePin(BOOST_EN_Port, BOOST_EN_Pin, GPIO_PIN_SET);
	HAL_Delay( 10 );
	HAL_GPIO_WritePin( RM_NRST_GPIO_Port, RM_NRST_Pin, GPIO_PIN_SET );
	HAL_Delay( 10 );
	HAL_GPIO_WritePin(RM_EN_Port, RM_EN_Pin, GPIO_PIN_SET);
	HAL_Delay( 10 );

	uartRxBuffClear();
	uartRxBuff2Clear();
	return findMatchNonblocking("EVENT", 5, 5000);

}

void lora_off( void )
{
	if (  nrf_mode == NO_NRF_MODE || nrf_mode == NRF_RESIDENTIAL_MODE ) {
		HAL_GPIO_WritePin(BOOST_EN_Port, BOOST_EN_Pin, GPIO_PIN_RESET);
	}
	HAL_GPIO_WritePin( RM_EN_Port, RM_EN_Pin, GPIO_PIN_RESET);
	HAL_GPIO_WritePin( RM_NRST_GPIO_Port, RM_NRST_Pin, GPIO_PIN_RESET );

	HAL_UART_DeInit(&huart2);
	HAL_UART_DeInit(&huart1);

	  HAL_NVIC_DisableIRQ(DMA1_Channel4_5_6_7_IRQn);
	  HAL_NVIC_DisableIRQ(DMA1_Channel2_3_IRQn);


	  HAL_GPIO_DeInit( MCU_RX_GPIO_Port, MCU_RX_Pin );

	  HAL_GPIO_DeInit( MCU_RX_GPIO_Port, MCU_TX_Pin );
	  HAL_GPIO_DeInit( GPIOA, GPIO_PIN_10 );



}

void lora_send_dr_command(  uint8_t dr  ) {
	HAL_UART_Transmit(&huart2, "\r", strlen("\r"), 500);
	HAL_Delay(500);
	char buf[ 100 ];

	sprintf( buf, "AT+DR=%d\r", dr );
	HAL_UART_Transmit(&huart2, buf, strlen(buf), 500);
	HAL_Delay(500);
	HAL_UART_Transmit(&huart2, "\r", strlen("\r"), 500);
	HAL_Delay(500);

}

void lora_set_dr( uint8_t dr ) {

	lora_on();

	lora_dr_data = dr;
	lora_send_dr_command( dr );
	lora_off();
}

void lora_init(void)
{


	//HAL_GPIO_WritePin( RM_NRST_GPIO_Port, RM_NRST_Pin, GPIO_PIN_SET );
	lora_on();

	//HAL_Delay(500);
	HAL_UART_Transmit(&huart2, "\r", strlen("\r"), 500);
	HAL_UART_Transmit(&huart2, "AT+VER?\r", strlen("AT+VER?\r"), 500);
	HAL_UART_Transmit(&huart2, "\r", strlen("\r"), 500);

	HAL_UART_Transmit(&huart2, "AT+FACNEW\r", strlen("AT+FACNEW\r"), 500);
	HAL_Delay(5000);
	HAL_UART_Transmit(&huart2, "AT+CLASS=0\r", strlen("AT+CLASS=0\r"), 500);
	HAL_Delay(500);
	HAL_UART_Transmit(&huart2, "AT+DFORMAT=1\r", strlen("AT+DFORMAT=1\r"), 500);
	HAL_Delay(500);
	HAL_UART_Transmit(&huart2, "AT+ADR=0\r", strlen("AT+ADR=0\r"), 500);
	HAL_Delay(500);
	HAL_UART_Transmit(&huart2, "AT+BAND=5\r", strlen("AT+BAND=5\r"), 500);

	HAL_Delay(500);
	HAL_UART_Transmit(&huart2, "AT+DR?\r", strlen("AT+DR?\r"), 500);
	HAL_Delay(500);
	HAL_UART_Transmit(&huart2, "AT+DR=0\r", strlen("AT+DR=0\r"), 500);

	HAL_Delay(500);
//#define OTA
#define ABP
#ifdef OTA
	HAL_UART_Transmit(&huart2, "AT+MODE=1\r", strlen("AT+MODE=1\r"), 500);
#endif
#ifdef ABP
	HAL_UART_Transmit(&huart2, "AT+MODE=0\r", strlen("AT+MODE=0\r"), 500);
#endif
	 HAL_IWDG_Refresh( &hiwdg );
	HAL_Delay(500);
//	HAL_UART_Transmit(&huart_radio, "AT+RFPOWER=1,0\r", strlen("AT+RFPOWER=1,0\r"), 500); 	//20dBm
//	HAL_UART_Transmit(&huart_radio, "AT+RFPOWER=0,0\r", strlen("AT+RFPOWER=1,0\r"), 500); 	//16dBm
	HAL_UART_Transmit(&huart2, "AT+MAXEIRP=20\r", strlen("AT+MAXEIRP=20\r"), 500);
	HAL_Delay(500);

	HAL_UART_Transmit(&huart2, "AT+RFPOWER=1,0\r", strlen("AT+RFPOWER=1,0\r"), 500);	//14dBm

	HAL_Delay(500);
	HAL_UART_Transmit(&huart2, "AT+DUTYCYCLE=0\r", strlen("AT+DUTYCYCLE=0\r"), 500);
	HAL_Delay(500);
	HAL_UART_Transmit(&huart2, "AT+SLEEP=0\r", strlen("AT+SLEEP=0\r"), 500);

	HAL_UART_Transmit(&huart2, "AT+VER?\r", strlen("AT+VER?\r"), 500);
	HAL_UART_Transmit(&huart2, "\r", strlen("\r"), 500);

	HAL_UART_Transmit( &huart2, "AT+NWKSKEY=9087654321AFBECD5647382910DACFEB\r" , strlen("AT+NWKSKEY=9087654321AFBECD5647382910DACFEB\r"), 1000);
	HAL_Delay(500);
	HAL_UART_Transmit( &huart2, "AT+APPSKEY=1029384756AFBECD5647382910DACFEB\r" , strlen("AT+APPSKEY=1029384756AFBECD5647382910DACFEB\r"), 1000);
	uartRxBuffClear();

	HAL_Delay(500);
	HAL_UART_Transmit( &huart2, "AT+DEVADDR?\r" , strlen("AT+DEVADDR?\r"), 1000);
	HAL_Delay(500);
	uartRxBuffClear();
	HAL_Delay(500);



	HAL_UART_Transmit( &huart2, "AT+DBG=3\r" , strlen("AT+DBG=3\r"), 1000);
	HAL_Delay(500);
	uartRxBuffClear();
	HAL_Delay(500);

	HAL_UART_Transmit( &huart2, "AT+DEVEUI?\r" , strlen("AT+DEVEUI?\r"), 1000);
	HAL_Delay(500);
	//data[]
	//un_device_id
	 HAL_IWDG_Refresh( &hiwdg );
	uint8_t position;
	if ( findMatchNonblockingPos( "+OK=", 4, 4000, &position ) == 1 ) {

	}else{
		for( uint8_t x = 0; x < 8; x+=1 ) {
			un_device_id[ x ] = x;
		}
		lora_off();
		return;
	}

	char hex[4];

	for( uint8_t x = 4; x < 20; x+=2 ) {
		hex[0] = uartRxBuff.data[ x ];
		hex[1] = uartRxBuff.data[ x + 1 ];

		un_device_id[ (x-4)/2 ] = strtol( hex, NULL, 16 );
	}

	HAL_Delay(500);
	HAL_UART_Transmit( &huart2, "AT+APPEUI?\r" , strlen("AT+APPEUI?\r"), 1000);
	HAL_Delay(500);
	HAL_UART_Transmit( &huart2, "AT+APPKEY?\r" , strlen("AT+APPKEY?\r"), 1000);
	HAL_Delay(500);
	HAL_UART_Transmit( &huart2, "AT+RTYNUM=1\r" , strlen("AT+RTYNUM=1\r"), 1000);
	HAL_Delay(500);
/*
	HAL_UART_Transmit(&huart2, "\rAT+JOIN\r", strlen("\rAT+JOIN\r"), 100 );
	uint64_t start = HAL_GetTick();
	while( ( start + 400000 ) > HAL_GetTick() )
	{
		if(findMatchNonblocking("EVENT=1,1", 9, 5000) == 1)
		{
			break;
		}
		if(findMatchNonblocking("EVENT=1,0", 9, 500) == 1)
		{
			uartRxBuffClear();
			HAL_UART_Transmit(&huart2, "AT+JOIN\r", strlen("AT+JOIN\r"), 100 );
		}
		HAL_GPIO_WritePin(LED_GPIO_Port, LED_Pin, GPIO_PIN_RESET);
		HAL_Delay(50);
		HAL_GPIO_WritePin(LED_GPIO_Port, LED_Pin, GPIO_PIN_SET);
	}
 */
	lora_off();
}

uint8_t lora_sends( char * command ) {
	uartRxBuffInit();
	uartRxBuff2Init();
	HAL_UART_Transmit( &huart2, "\r", 1, DEFAULT_UART_TIMEOUT );
	HAL_Delay( 25 );
	HAL_UART_Transmit( &huart2, command, strlen( command ), DEFAULT_UART_TIMEOUT );
	HAL_IWDG_Refresh( &hiwdg );

	uint8_t resp1 = lora_recv_mac();

	if ( resp1 == 1 ) {
		uint8_t ack_msg_old = ack_msgs;
		HAL_UART_Transmit( &huart2, "\r", 1, DEFAULT_UART_TIMEOUT );
		HAL_Delay( 25 );
		HAL_UART_Transmit( &huart2, "\rAT+UTX 1\r61\r\0", strlen( "\rAT+UTX 1\r61\r\0" ), DEFAULT_UART_TIMEOUT );
		HAL_IWDG_Refresh( &hiwdg );
		HAL_Delay( 2000 );
	}


	HAL_Delay( 500 );
	return 0;
}


uint8_t lora_send( char * command, uint8_t ack ) {
	//SystemClock_Config1();
	uartRxBuffInit();
	uartRxBuff2Init();
	HAL_UART_Transmit( &huart2, "\r", 1, DEFAULT_UART_TIMEOUT );
	HAL_Delay( 25 );
	HAL_UART_Transmit( &huart2, command, strlen( command ), DEFAULT_UART_TIMEOUT );
	uint8_t resp1 = lora_recv_mac();

	if ( resp1 == 1 ) {
		uint8_t ack_msg_old = ack_msgs;
		HAL_UART_Transmit( &huart2, "\r", 1, DEFAULT_UART_TIMEOUT );
		HAL_Delay( 25 );
		HAL_UART_Transmit( &huart2, "\rAT+UTX 1\r61\r\0", strlen( "\rAT+UTX 1\r61\r\0" ), DEFAULT_UART_TIMEOUT );
		HAL_Delay( 2000 );
	}

	HAL_Delay( 10 );

	char response_buffer[ 205 ];
	uint8_t downlink_resp =  wait_for_recv( response_buffer );

	uint16_t crc = doCrc( response_buffer, downlink_resp );
	uint8_t resp = 0;
	if ( downlink_resp != 0 && downlink_resp != 254 )
		resp = lora_recv_msg( response_buffer );

	if ( resp == ID_SETTINGS ) {
		send_msg_id();
	}

	if ( resp == VERSION_SETTINGS ) {
		send_msg_version();
	}

	if ( resp == BASELINE_VALUE ) {
		send_msg_baseline();
	}

	if ( resp == LAIRD_VERSION_VALUE ) {
		initNRF();
		uint32_t ver = getLairdNrfVersion();

		send_msg_laird_version( ver );

	}

	if ( resp != NO_COMMAND ) {
		send_msg_system_ok_confirmation( resp, 0, (uint8_t)(crc & 0xFF) );
		return 1;
	}else if ( downlink_resp == ACK_COMMAND || ack == 0 ) {
		return 1;
	}

	return 0;
}

void lora_join_network() {

	//HAL_GPIO_WritePin(RM_EN_GPIO_Port, RM_EN_Pin, GPIO_PIN_SET);
	//HAL_GPIO_WritePin( RM_NRST_GPIO_Port, RM_NRST_Pin, GPIO_PIN_SET );
	//HAL_GPIO_WritePin(LED_GPIO_Port, LED_Pin, GPIO_PIN_RESET);
	//HAL_Delay(10000); //wait for power up radio
	//HAL_GPIO_WritePin(LED_GPIO_Port, LED_Pin, GPIO_PIN_SET);

	lora_on();

	uartRxBuffClear();
	//while(1)
	HAL_UART_Transmit(&huart2, "\rAT+JOIN\r", strlen("\rAT+JOIN\r"), 100 );
	uint64_t start = HAL_GetTick();
	while( ( start + 400000 ) > HAL_GetTick() )
	{
		if(findMatchNonblocking("EVENT=1,1", 9, 5000) == 1)
		{
			break;
		}
		if(findMatchNonblocking("EVENT=1,0", 9, 500) == 1)
		{
			uartRxBuffClear();
			HAL_UART_Transmit(&huart2, "AT+JOIN\r", strlen("AT+JOIN\r"), 100 );
		}
		HAL_GPIO_WritePin(LED_GPIO_Port, LED_Pin, GPIO_PIN_RESET);
		HAL_Delay(50);
		HAL_GPIO_WritePin(LED_GPIO_Port, LED_Pin, GPIO_PIN_SET);
	}
/*
	HAL_GPIO_WritePin(RM_EN_GPIO_Port, RM_EN_Pin, GPIO_PIN_RESET);
	HAL_GPIO_WritePin( RM_NRST_GPIO_Port, RM_NRST_Pin, GPIO_PIN_RESET );
*/
	//murata_send_periodic_data( "0F" );

	lora_off();
}
/*
void murata_send_periodic_data_p( char * data, uint8_t power )
{

	char msg_radio[13] = "\rAT+UTX 1\rxx\r";
	memcpy(msg_radio+10, data, 2);
	murata_send_p( msg_radio, 13, power );

}


void murata_send_periodic_data( char * data )
{

	char msg_radio[13] = "\rAT+UTX 1\rxx\r";
	memcpy(msg_radio+10, data, 2);
	murata_send( msg_radio, 13 );

}

void murata_send_n_bytes( char * data , uint8_t n)
{
	char msg_radio[22] = "AT+UTX 1\rxx\r";
	memcpy(msg_radio+9, data, n);
	memcpy(msg_radio+9+n, "\r", 1);
	murata_send( msg_radio, 10 + n );
}
*/
/*
AT+REBOOT
AT+FACNEW

//AT+CLASS A

AT+MODE=1

AT+JOIN // raz pri prechode do operational modu
AT+CTX// raz za den sprava s ACK, ak nepride ACK -> join

AT+DUTYCYCLE

AT+SLEEP

AT+PORT

AT+REP

AT+DFORMAT

AT+UTX  // poslanie spravy bez ack

*/
