/*
 * murata.h
 *
 *  Created on: Aug 18, 2017
 *      Author: fiala
 */

#ifndef MURATA_H_
#define MURATA_H_

#include "main.h"
#include "gpio.h"
#include "parking.h"
#include "nvm.h"
#include "usart.h"
#include "bootloader.h"
#include "uartRxBuff.h"


#define DEFAULT_UART_TIMEOUT 500
#define DEFAULT_UART_COMMAND_TIMEOUT 500

#define NO_DATA_RECEIVED 0
#define DATA_RECEIVED 1

#define EMPTY_MSG 0
#define RESTART_MSG 250
#define SETTINGS_MSG 249
#define BASELINE_MSG 248
#define KA_SETTINGS 247
#define OP_SETTINGS 246
#define ID_SETTINGS 245
#define VERSION_SETTINGS 244
#define BASELINE_VALUE 243
#define POINT_VALUES 242
#define POINT_VALUES_BASE 241
#define LAIRD_VERSION_VALUE 240

#define NO_CHANGE 0

void lora_init(void);
void lora_join_network();
uint8_t lora_on ( void );
void lora_off( void );
void lora_UART_Init(void);
void lora_set_power( char * command );
uint8_t lora_recv_msg( char * response_buffer );
uint8_t lora_send( char * command, uint8_t ack );
void lora_send_mac_commands();
void lora_set_dr( uint8_t dr );

#endif /* MURATA_H_ */
