/*
 * circleBuffer.c
 *
 *  Created on: Jul 6, 2018
 *      Author: Tomas
 */

#include "lux_meter.h"

void initLuxMeter( LuxMeterData * data  ) {
	data->last_send = 0;
	data->scale = 0;
}

void setNewLuxMeas() {
	 uint8_t data[ 5 ];
	 data[ 0 ] = 0x03;
	 HAL_I2C_Mem_Write( &hi2c1, 82,  0xA0|0x00, 1, &data, 1, 500 );

}

uint32_t getLuxData() {

	uint8_t data[ 4 ];

	  data[ 0 ] = 0;
	  data[ 1 ] = 0;
	  data[ 2 ] = 0;
	  data[ 3 ] = 0;

	  HAL_I2C_Mem_Read( &hi2c1, 82, 0xA0| 0x14, 1, &data, 4, 1000  );

	  uint16_t light = (data[1] << 8 ) + data[0];
	  uint16_t ir = (data[3] << 8 ) + data[2];


	  return (light << 16) | (ir);
}

uint32_t stepLuxMeter( LuxMeterData * datat ) {
	  uint8_t data[ 4 ];
	  uint32_t datas = getLuxData();
	  setNewLuxMeas();
	  HAL_Delay( 300 );
	  datas = getLuxData();


	  uint16_t light = datas >> 16;
	  uint16_t ir = datas & 0xFFFF;

	  return datas;
}
