/*
 * mode_residential_parking.c
 *
 *  Created on: Nov 8, 2019
 *      Author: Tomas
 */

#include "mode_residential_parking.h"

void residentialParkingInit() {
    startNRF( RECEIVE_RESIDENTIAL_PARKING );
    residential_items_counts = 0;

	  for( uint8_t x = 0; x < 9; x++ ) {
		  deveui_snr[ x ] = 0;
	  }
	  for( uint8_t x = 0; x < 9; x++ ) {
		  deveui_packet_count[ x ] = 0;
	  }
}

void residentialParkingEnd() {
	stopNRFMode();
}


uint8_t residentialParkingStep() {

	  uint8_t found = 0;


	  HAL_IWDG_Refresh( &hiwdg );
	  while ( nRF52PacketReceived() == 1 ) {

		uint8_t buffer[32];
		for( uint8_t x = 0; x < 32; x++ ) {
			buffer[ x ] = 0;
		}
		if ( nRF52getPacket( &buffer ) == 1 ) {
			  if ( buffer[ 0 ] == 0xAA && buffer[ 1 ] == 0xAB ) {
				  //nRF52deinit();
				  blinkLed( 50 );

				  uint32_t potential_new_id = (buffer[ 5 ] << 16) + (buffer[ 4 ] << 8) + (buffer[ 3 ] ) ;
				  uint8_t already_present = 0;
				  for( uint8_t x = 0; x < residential_items_counts; x++ ) {
						 if ( deveui_ids[ x ] == potential_new_id ) {
							 already_present = 1;
							 if ( deveui_packet_count[ x ] < 60000 )
								 deveui_packet_count[ x ] += 1;
							 break;
						 }
				  }

				  if ( already_present == 1 )
					  continue;
				  found = 1;
				  deveui_ids[ residential_items_counts ] = potential_new_id;
				  deveui_snr[ residential_items_counts ] += buffer[ 31 ];
				  deveui_packet_count[ residential_items_counts ] = 1;

				  //send_msg_park_residential(main_loop.park_state_x, main_loop.park_state_y, main_loop.park_state_z, main_loop.park_state_x,buffer, POWER_20 );

				  residential_items_counts = residential_items_counts + 1;
				  if ( residential_items_counts > 6 )
					  break;
			  }
		}

	  }


	  return found;
}
