/*
 * mode_storage.c
 *
 *  Created on: Aug 3, 2017
 *      Author: fiala
 */

#include "mode_storage.h"

/** System Clock Configuration
*/
void storageMode() {

	uint64_t hg = HAL_GetTick();

	HAL_GPIO_WritePin( PHT_EN_GPIO_Port, PHT_EN_Pin, GPIO_PIN_SET );
	HAL_Delay( 5 );

	HAL_NVIC_SetPriority(EXTI2_3_IRQn, 0, 0);
	HAL_NVIC_EnableIRQ(EXTI2_3_IRQn);
	initNRF();
	startNRF( RECEIVE_COMMANDS );

	while( ( hg + STORAGE_MODE_LIGHT_DELAY ) > HAL_GetTick() ) {
		HAL_GPIO_WritePin( LED_GPIO_Port, LED_Pin, GPIO_PIN_RESET );
		HAL_Delay( 50 );
		HAL_GPIO_WritePin( LED_GPIO_Port, LED_Pin, GPIO_PIN_SET );
		HAL_Delay( 4000 );
		HAL_IWDG_Refresh( &hiwdg );
		nRFCommandStep();

	}
	stopNRFMode();
	// __HAL_RCC_GPIOB_CLK_DISABLE();
	pht_int = NO_INTERRUPT;
	HAL_IWDG_Refresh( &hiwdg );
	setRTCstorageModeTimeout();
	HAL_PWR_EnterSTOPMode(PWR_LOWPOWERREGULATOR_ON, PWR_SLEEPENTRY_WFI);

	while(1) {
		if ( pht_int == INTERRUPT ) {
			 	// __HAL_RCC_GPIOB_CLK_ENABLE();
				HAL_GPIO_WritePin( LED_GPIO_Port, LED_Pin, GPIO_PIN_RESET );
				HAL_Delay( 5000 );
				HAL_GPIO_WritePin( LED_GPIO_Port, LED_Pin, GPIO_PIN_SET );

				HAL_GPIO_WritePin( PHT_EN_GPIO_Port, PHT_EN_Pin, GPIO_PIN_RESET );

				HAL_NVIC_DisableIRQ(EXTI2_3_IRQn);
			break;
		}else{
			setRTCstorageModeTimeout();
			HAL_IWDG_Refresh( &hiwdg );
			HAL_PWR_EnterSTOPMode(PWR_LOWPOWERREGULATOR_ON, PWR_SLEEPENTRY_WFI);
		}
	}
	HAL_IWDG_Refresh( &hiwdg );
}
