/*
 * nvm.c
 *
 *  Created on: Jul 3, 2017
 *      Author: fiala
 */

#include "nvm.h"


void writeDataToMemory() {

}

void nvmWriteOperatingMode( uint8_t mode ) {
	 uint32_t data;
	 data = 0xAE << 24;
	 data += 0xBC << 16;
	 data += mode << 8;
	 data += 0;

	 nvmWriteByte( OPERATING_MODE_EEPROM_CHECK1, data );

}


void nvmSetNumberOfIWDGRestarts( uint32_t number_of_restart ) {

	//nvmWriteByte( OPERATING_MODE_EEPROM_IWDG_RESTARTS, number_of_restart );

}

uint32_t nvmGetNumberOfIWDGRestarts() {
	//uint32_t number = nvmReadByte( OPERATING_MODE_EEPROM_IWDG_RESTARTS );

	return 0;

}

uint8_t nvmGetOperatingMode() {

	uint32_t data =  nvmReadInteger( 0 );

	uint8_t correct = 0;

	if ( ( ( data >> 24 ) & 0xFF ) == 0xAE ){
		correct++;
	}

	if ( ( ( data >> 16 ) & 0xFF ) == 0xBC ){
			correct++;
	}
	if ( correct != 2 )
		return MEMORY_INVALID;

	return ( ( data >> 8 ) & 0xFF );

}

void nvmErase() {
	uint64_t addr = 0x08080000;

	while( HAL_FLASHEx_DATAEEPROM_Unlock() != HAL_OK );

	while(1) {
		HAL_FLASHEx_DATAEEPROM_Program(FLASH_TYPEPROGRAMDATA_BYTE, addr, 0);
		addr++;

		if ( 0x08080000 + 100 > addr ) {
			break;
		}
	}
	HAL_FLASHEx_DATAEEPROM_Lock();
}

void nvmWriteByte(uint32_t addr, uint32_t data )
{
	uint64_t time = HAL_GetTick();

	while( HAL_FLASHEx_DATAEEPROM_Unlock() != HAL_OK ){
		if ( time + 30000 < HAL_GetTick() ) {
			return;
			break;
		}
	}

	time = HAL_GetTick();
	uint32_t dat;
	while( dat != data && time + 3000 > HAL_GetTick() ) {
		HAL_FLASHEx_DATAEEPROM_Program(FLASH_TYPEPROGRAMDATA_WORD, 0x08080000 + addr, data);



		dat = nvmReadInteger( addr );
	}

	time = HAL_GetTick();
	while( HAL_FLASHEx_DATAEEPROM_Lock() != HAL_OK ){
		if ( time + 30000 < HAL_GetTick() ) {
			return;
			break;
		}
	}

}

uint8_t nvmReadByte(uint32_t addr)
{

	uint32_t data;
	data = *(__IO uint8_t*) ( 0x08080000 + addr );
	//memcpy(data, 0x08080000, 1);
	return data;
}


uint32_t nvmReadInteger(uint32_t addr)
{

	uint32_t data;
	data = *(__IO uint32_t*) ( 0x08080000 + addr );
	//memcpy(data, 0x08080000, 1);
	return data;
}


