/*
 * parking.c
 *
 *  Created on: Apr 27, 2017
 *      Author: fiala
 */

#include "parking.h"

extern UART_HandleTypeDef huart_radio;


/*
#define threshold1	50 // stop integracii
#define threshold2  	60 // enterring flux
#define thresholdUP 	110 // r flux
#define thresholdDOWN 80 // l value below which unparking is considered
*/
/*
#define threshold1	40 // stop integracii
#define threshold2  	50 // enterring flux
#define thresholdUP 	240 // r flux
#define thresholdDOWN 200 // l value below which unparking is considered
*/
#ifdef BOTH_MAGNETOMETERS
#define threshold1	40 // stop integracii
#define thresholdUP 	120 // r flux
#define thresholdDOWN 100 // l value below which unparking is considered with flux

#endif

#ifdef LIS3MDL
	#define threshold1	10 // stop integracii
	#define threshold2  	40 // enterring flux
	#define thresholdUP 	25 // r flux
	#define thresholdDOWN 15 // l value below which unparking is considered with flux
	#define thresholdBELOWDOWN 40 // l value below which unparking is considered without flux
#endif
/*
#define threshold1	50 // stop integracii
#define threshold2  	90 // enterring flux
#define thresholdUP 	50 // r flux
#define thresholdDOWN 40 // l value below which unparking is considered with flux
#define thresholdBELOWDOWN 100 // l value below which unparking is considered without flux
*/
void parking_init( parking_tomas_t * parking_tomas )
{

    parking_tomas->threshold_down = thresholdDOWN;

    parking_tomas->threshold_up = thresholdUP;

    parking_tomas->threshold_intg = threshold1;


    parking_tomas->alpha = 10;
    parking_tomas->buffer_pos = 0;
    parking_tomas->buffer_size = 120;
    parking_tomas->b_old = 0;

    parking_tomas->state = 1;

    parking_tomas->s3_n_counter = 0;
    parking_tomas->s5_n_counter = 0;
    parking_tomas->s6_n_counter = 0;

    parking_tomas->bellum = 0;

    parking_tomas->park_status = 0;

    parking_tomas->diff = 0;
    parking_tomas->a = 0;
    parking_tomas->c = 0;

    parking_tomas->main_counter = 0;
    for(int i =0; i<parking_tomas->buffer_size; i++)

    {
        parking_tomas->buffer[i] = 0;
    }
    parking_tomas->g = 0;
    parking_tomas->total_diff = 0;
    parking_tomas->warm_up_time = parking_tomas->buffer_size + 10;



    parking_tomas->s3_n_counter_threshold = 40;
    parking_tomas->s5_n_counter_threshold = 60;
    parking_tomas->s6_n_counter_threshold = 2;

    parking_tomas->main_counter_threshold = parking_tomas->buffer_size + 20;
    //bufferInit( &(parking_tomas->buffer) );
    CBinit( &parking_tomas->circle_buffer );
}



uint8_t parkingStateMachine( parking_tomas_t * parking_tomas, int32_t diff ) {

    uint8_t r = 0;
    if (diff >= (parking_tomas->threshold_up*parking_tomas->threshold_up) )
    {
        r = 1;

    }


    uint8_t l = 1;
    if ( ( diff ) <= (  parking_tomas->threshold_down*parking_tomas->threshold_down  ) )
    {
        l = 0;
    }

    uint8_t h = 0;

    if ( parking_tomas->main_counter <= parking_tomas->main_counter_threshold ) {
        parking_tomas->main_counter++;
        return 0;
    }



    if (parking_tomas->state == 1 )
    {
        //send_msg_ready();
        parking_tomas->state = 2;
    }
    else if (parking_tomas->state == 2)
    {

        if ( (r == 1) || (r == 1 && forced_baseline == 1) )
        {
            parking_tomas->state = 3;
            forced_baseline = 0;
        }


    }
    else if (parking_tomas->state == 3)
    {
        if (parking_tomas->s3_n_counter > parking_tomas->s3_n_counter_threshold )
        {


            parking_tomas->s3_n_counter = 0;
            parking_tomas->state = 4;

        }
        if (r == 1)
        {
            parking_tomas->s3_n_counter = parking_tomas->s3_n_counter + 1;

        }
        else if ( r == 0 )
        {
            parking_tomas->s3_n_counter = 0;
            parking_tomas->state = 6;
        }
    }
    else if (parking_tomas->state == 4)
    {


        if ( (( l == 0 )) ||  (( l == 0 ) && forced_baseline == 1) )
        {
            parking_tomas->state = 5;
            forced_baseline = 0;
        }


    }
    else if (parking_tomas->state == 5)
    {

        if (l == 0)
        {
            parking_tomas->s5_n_counter = parking_tomas->s5_n_counter + 1;
            if (parking_tomas->s5_n_counter > parking_tomas->s5_n_counter_threshold )
            {
                parking_tomas->s5_n_counter = 0;
                parking_tomas->state = 2;


            }
        }
        else if (l == 1)
        {
            parking_tomas->s5_n_counter = 0;
            parking_tomas->state = 4;
        }

    }
    else if (parking_tomas->state == 6)
    {

        if (r == 1)
        {
            parking_tomas->state = 3;
            parking_tomas->s6_n_counter = 0;
        }
        else if (r == 0)
        {

            parking_tomas->s6_n_counter = parking_tomas->s6_n_counter + 1;

            if ( parking_tomas->s6_n_counter > parking_tomas->s6_n_counter_threshold ) {

                parking_tomas->state = 2;
                parking_tomas->s6_n_counter = 0;

            }

        }

    }


/*
    uint8_t str[2];
    get_dec_str(str, 2, parking_tomas->state);
    HAL_UART_Transmit(&huart2, "State: ", 7, 100);
    HAL_UART_Transmit(&huart2, str, 2, 100);
    HAL_UART_Transmit(&huart2, "\r\n", 2, 100);
*/
    //return parking_tomas->zaparkovane;


    if( parking_tomas->state > 3 && parking_tomas->state != 6 ) {
        parking_tomas->park_status = 1;
        return 1;

    }else{
        parking_tomas->park_status = 0;
        return 0;

    }
}

int32_t parking_step( parking_tomas_t * parking_tomas, int16_t x, int16_t y, int16_t z )
{
	// Not for the faint of heart
    int32_t g;

    g = x;
    RTC->BKP1R = STATE_PARKING_CALC_ACTIVE;

    CBPush( &parking_tomas->circle_buffer, g );


    g = CBGet( &parking_tomas->circle_buffer );

    parking_tomas->g = g;

    parking_tomas->buffer [ parking_tomas->buffer_pos ] = g;
    parking_tomas->buffer_pos = parking_tomas->buffer_pos + 1;

    if (parking_tomas->buffer_pos >= parking_tomas->buffer_size)
    {
        parking_tomas->buffer_pos = 0;
    }

    int32_t buffer_output = 0;

    for (int i = 0; i < parking_tomas->buffer_size; i++)
    {
        buffer_output = buffer_output + parking_tomas->buffer[i];
    }

    buffer_output = buffer_output / parking_tomas->buffer_size;

    int32_t a = buffer_output;
    int c = 0;

    for (int i = 0; i < parking_tomas->buffer_size; i++)
    {
        if ( abs( parking_tomas->buffer[ i ] - g ) > parking_tomas->threshold_intg )
        {
            c = 1;
            break;
        }
    }

    parking_tomas->c = c;


    //logger mode updates



    if ( ( ( c == 0 && parking_tomas->state < 3 ) || parking_tomas->main_counter <  parking_tomas->warm_up_time )  )
    {
        if ( parking_tomas->main_counter >= parking_tomas->warm_up_time  ) {
            double temp1 = ((double)(a)) * 0.1;
            temp1 = temp1;

            double temp3 = ( parking_tomas->b_old * ( 1 - 0.1 ) );

            if ( using_baseline_integration == 1 )
            	parking_tomas->bellum = temp3 + temp1;

        }else{
            parking_tomas->bellum = a;
        }

    }


    parking_tomas->a = a;


    int32_t temp1 = abs( a - ( parking_tomas->b_old ) );

    if ( temp1 > 200000 )
    	temp1 = 200000;

    parking_tomas->diff = temp1*temp1;

    temp1 = temp1*temp1;

    parking_tomas->b_old = parking_tomas->bellum;



    return parkingStateMachine( parking_tomas, temp1 );

}

void parkingStep( Mag3110 * val ) {

	int32_t y_l = val->y;
	int32_t z_l = val->z;
	int32_t x_l = val->x;

	int32_t vals = ( sqrt( (y_l*y_l) + (z_l*z_l) ) );

	float vals1 = atan2( ( y_l ), (z_l) );
	if ( vals1 == 0 ) {
		asm( "nop" );
	}

	int32_t vals2 = (vals1 * 1000);

	vals2 =  ( abs( vals2 ) );
	int32_t vals3 =  ( atan2( vals , x_l ) * 1000 );

	vals3 =  ( abs( vals3 ) );
	int32_t vals4 = sqrt( (y_l*y_l) + (z_l*z_l) + (x_l*x_l) );

	main_loop.park_state_x = parking_step( &data_x, val->x, val->y, val->z );
	main_loop.park_state_mag = parking_step( &data_mag, vals, 0, 0 );
	main_loop.park_state_rotation = parking_step( &data_rotation, vals2, 0, 0 );
	main_loop.park_state_total = parking_step( &data_total, vals3, 0, 0 );
	main_loop.park_state_mag_total = parking_step( &data_mag_total, vals4, 0, 0 );


}

void send_park_msg( uint8_t stav_park, uint8_t stav_batt)
{
	uint8_t msg = 0b00000000;

	msg |= ( stav_park & 0b00000001 );
	msg |= ( stav_batt & 0b00000111 ) << 1;

	char hex[2];
	dataToHex(hex, msg);

	#ifdef NEMEUS
	#ifdef SIGFOX
	//compose message for radio module
	char msg_radio[22] = "\r\nAT+SF= SNDBIN,xx,0\r\n";
	char msg_len = 22;
	//add useful information, replace "xx" with data byte in hex format
	memcpy(msg_radio+16, hex, 2);
	#endif
#endif
#ifdef MURATA
	murata_send_periodic_data( hex );
#endif
#ifdef WISOL
	char msg_radio[10] = "AT$SF=xx\r\n";
	memcpy(msg_radio+6, hex, 2);
	WISOL_send( msg_radio, 10);

#endif
}

