/*
 * parking_msgs.c
 *
 *  Created on: Sep 19, 2017
 *      Author: fiala
 */

#include "parking_msgs.h"
#include <string.h>
//#include "murata.h"
#include "radio.h"
#include <ctype.h>
uint8_t total_msg_count = 0;

void send_msg_system_recv( uint8_t OOB_flag, char * output_buffer )
{
	uint8_t msg = 0b00000000;
	msg |= 0 << 3;
	msg |= OOB_flag << 2;
	msg |= 0 << 1;
	msg |= 0;

	char hex[2];
	dataToHex(hex, msg);
	radio_on();
	HAL_Delay( 25 );
	radio_set_power( POWER_20 );
	HAL_Delay( 25 );
	radio_recv_msg( output_buffer ,hex );
	radio_off();
}

void send_msg_network( uint8_t mac_service, uint8_t OOB, uint8_t MSG_LIMIT )
{
	uint8_t msg = 0b00000000;
	msg |= MSG_LIMIT << 2;
	msg |= OOB << 1;
	msg |= mac_service;
	msg |= ( MSG_ID_NETWORK ) << 5;

	char hex[2];
	dataToHex(hex, msg);

	send_msg( hex, POWER_20 );
}

void send_msg_bootloader_progress(  uint16_t packet_num )
{
	char buffer[ 150 ];
	uint8_t msg = 0b00000000;

	msg |= ( MSG_ID_PARK_BOOTLOADER ) << 5;
	msg |= 1 << 2;


	buffer[ 0 ] = msg;

	sprintf( buffer, "%02X%04X", msg, packet_num );

	send_multibyte_msg( buffer, strlen( buffer ), 0 );
}


void send_msg_bootloader_laird_progress(  uint16_t packet_num )
{
	char buffer[ 150 ];
	uint8_t msg = 0b00000000;

	msg |= ( MSG_ID_LAID_BOOTLAODER ) << 5;
	msg |= 1 << 1;


	buffer[ 0 ] = msg;

	sprintf( buffer, "%02X%04X", msg, packet_num );

	send_multibyte_msg( buffer, strlen( buffer ), 0 );
}



void send_msg_laird_bootloader(  uint8_t transfer_done, uint8_t transfer_progress, uint16_t progress )
{
	uint8_t msg = 0b00000000;

	msg |= ( MSG_ID_LAID_BOOTLAODER ) << 5;
	msg |= transfer_progress << 1;
	msg |= transfer_done;

	char hex[2];
	dataToHex(hex, msg);

	send_msg( hex, POWER_20 );
}



void send_msg_bootloader(  uint8_t transfer_ok, uint8_t bootloader_failed, uint8_t half_complete, uint8_t entering_bootloader )
{
	uint8_t msg = 0b00000000;

	msg |= ( MSG_ID_PARK_BOOTLOADER ) << 5;
	msg |= entering_bootloader << 3;
	msg |= half_complete << 2;
	msg |= bootloader_failed << 1;
	msg |= transfer_ok;

	char hex[2];
	dataToHex(hex, msg);

	send_msg( hex, POWER_20 );
}


void send_msg_version() {
	char buffer[ 50 ];

	sprintf( buffer, "%02X%02X%02X%02X%02X", 0x10, SYSTEM_VERSION[0], SYSTEM_VERSION[1], SYSTEM_VERSION[2], SYSTEM_VERSION[3] );
	send_multibyte_msgs( buffer, strlen( buffer ) );

}

void send_msg_id() {
	char buffer[ 50 ];

	sprintf( buffer, "%02X%02X%02X%02X%02X%02X%02X%02X%02X", 0xFF, un_device_id[ 0 ], un_device_id[ 1 ], un_device_id[ 2 ], un_device_id[ 3 ], un_device_id[ 4 ], un_device_id[ 5 ], un_device_id[ 6 ], un_device_id[ 7 ]  );
	send_multibyte_msg( buffer, strlen( buffer ), 1 );

}

void decToHex( int16_t ineger, char * buf ) {
	char buffer[ 20 ];

	itoa( ineger, buffer, 16 );

	if ( strlen( buffer ) > 4 ) {
		for( uint8_t x = 0; x < 5 ; x++ ) {
			buffer[ x ] = buffer[ x + 4 ];
		}

	}

	for( int x = 0; x < 4 - strlen( buffer ); x++ ) {
		buf[ x ] = '0';
	}

	for( int x = 0; x < strlen( buffer ); x++ ) {
		buf[ x + (4 - strlen( buffer ) ) ] = buffer[ x ];
	}


}

void send_msg_system_ok_confirmation( uint8_t code, uint8_t type, uint8_t crc ) {
	uint8_t msg = 4;
	char buffer[ 10 ];
	sprintf( buffer, "%02X%02X%02X%02X", msg, type, code, crc );
	send_multibyte_msg( buffer, strlen( buffer ), 1 );

}

void send_msg_system( uint8_t start_flag, uint8_t integration_flag, uint8_t wake_up_flag, uint8_t OK_FLAG, uint8_t version, uint8_t count, int16_t baseline, int16_t baseline1, int16_t baseline2, int16_t baseline3, int16_t baseline4, char * buff )
{
	uint8_t msg = 0b00000000;
	msg |= version << 4;
	msg |= wake_up_flag << 3;
	msg |= OK_FLAG << 2;
	msg |= integration_flag << 1;
	msg |= start_flag;

	if ( wake_up_flag == 1 ) {
		char buffer[ 10 ];
		sprintf( buffer, "%02X%02X", msg, count );

		send_multibyte_msgs( buffer, strlen( buffer ) );

	}else if ( integration_flag == 1 ){
		char buffer[ 20 ];
		char res_buffer[ 23 ];

		sprintf( res_buffer, "%02X", msg );

		decToHex( baseline, buffer );

		for( uint8_t x = 0; x < 4; x++ ) {
			res_buffer[ x+2 ] = buffer[ x ];
		}

		decToHex( baseline1, buffer );

		for( uint8_t x = 0; x < 4; x++ ) {
			res_buffer[ x+6 ] = buffer[ x ];
		}

		decToHex( baseline2, buffer );

		for( uint8_t x = 0; x < 4; x++ ) {
			res_buffer[ x+10 ] = buffer[ x ];
		}

		decToHex( baseline3, buffer );

		for( uint8_t x = 0; x < 4; x++ ) {
			res_buffer[ x+14 ] = buffer[ x ];
		}

		decToHex( baseline4, buffer );

		for( uint8_t x = 0; x < 4; x++ ) {
			res_buffer[ x+18 ] = buffer[ x ];
		}
		res_buffer[ 22 ] = '\0';

		send_multibyte_msgs( res_buffer, strlen( res_buffer ) );

	}else if ( version == 1 ){
		char buffer[ 20 ];
		char res_buffer[ 20 ];

		sprintf( res_buffer, "%02X", msg );

		decToHex( baseline, buffer );

		for( uint8_t x = 0; x < 4; x++ ) {
			res_buffer[ x+2 ] = buffer[ x ];
		}

		decToHex( baseline1, buffer );

		for( uint8_t x = 0; x < 4; x++ ) {
			res_buffer[ x+6 ] = buffer[ x ];
		}

		decToHex( baseline2, buffer );

		for( uint8_t x = 0; x < 4; x++ ) {
			res_buffer[ x+10 ] = buffer[ x ];
		}

		decToHex( baseline3, buffer );

		for( uint8_t x = 0; x < 4; x++ ) {
			res_buffer[ x+14 ] = buffer[ x ];
		}

		send_multibyte_msgs( res_buffer, strlen( res_buffer ));

	}else{


		char hex[2];
		dataToHex(hex, msg);
		send_msg( hex, POWER_20 );
	}





}

void send_multibyte_msgs( char * buffer, int len ) {
	radio_on();
	HAL_Delay( 25 );
	radio_set_power( POWER_20 );
	HAL_Delay( 100 );

	//stuffByte( buffer, temp_buffer );


	if ( ack_msgs == 1 ) {
		uint8_t count = 0;
		while( count < 3 ) {
			if ( radio_send_multibyte_msg( buffer, strlen( buffer ) / 2, 0, 1 ) == 1 )
				break;
			count++;
		}

	}else{
		radio_send_multibyte_msg( buffer, strlen( buffer ) / 2, 0, 0 );
	}
	radio_off();
}


void send_multibyte_msg( char * buffer, int len, uint8_t ignore_downlinks ) {
	radio_on();
	HAL_Delay( 25 );
	radio_set_power( POWER_20 );
	HAL_Delay( 100 );

	//stuffByte( buffer, temp_buffer );



    radio_send_multibyte_msg( buffer, strlen( buffer ) / 2, ignore_downlinks, 0 );
	radio_off();
}

void send_msg( char * hex, uint8_t power ) {
	uint8_t state = frame_count();
	if ( state == CANT_SEND ) {
		return;
	}else if ( state == LAST_SEND ) {
		radio_on();
		HAL_Delay( 25 );
		radio_set_power( POWER_20 );
		HAL_Delay( 100 );
		radio_send_msg( "64", 0 );
		HAL_Delay( 25 );
		radio_off();
		return;
	}

	radio_on();
	/*
	HAL_UART_Transmit( &huart2, "\r", 1, 20 );
	HAL_Delay( 25 );
	*/
	radio_set_power( power );
	HAL_Delay( 25 );

	uint8_t retransmission_n_count = 0, resp_received = 0;

	while( resp_received == 0 ) {

		if ( retransmission_n_count > ack_n_timeout ) {
			break;
		}
		resp_received = radio_send_msg( hex, ack_msgs );

		//if ack is not set we are not waiting for acknowledge, UDP style
		if ( ack_msgs == 0 )
			resp_received = 1;

		retransmission_n_count++;
	}

	//HAL_Delay( 5000 );
	radio_off();

}

void send_msg_park_residential( uint8_t x_status, uint8_t y_status, uint8_t z_status, uint8_t total_status, uint8_t park, uint32_t * buffer, uint8_t size, uint8_t * buffer_snr, uint16_t * buffer_count , uint8_t power )
{
	uint8_t msg = 0b00000000;

	msg |= park;
	msg |= total_status << 4;
	msg |= z_status << 3;
	msg |= y_status << 2;
	msg |= x_status << 1;
	msg |= ( MSG_ID_PARK_TEMPERATURE ) << 5;

	char hex[2];

	char temp_buffer[ 80 ];
	char temp_buffer1[ 80 ];
	char temp_buffer2[ 80 ];
	char msg_buffer[ 100 ];



	//sprintf( msg_buffer, "%02X", 0x41 );
	/*
	msg_buffer[ 0 ]  = '4';
	msg_buffer[ 1 ]  = '1';
	msg_buffer[ 2 ]  = '0';
	msg_buffer[ 3 ]  = '4';
	*/
	sprintf( msg_buffer, "%02X", msg );
	msg_buffer[2] = '0';
	msg_buffer[3] = '4';

	uint32_t char_pos = 4;

	for ( int x = 0; x < size; x++ ) {

		sprintf( temp_buffer, "%06x", buffer[x] );
		sprintf( temp_buffer1, "%02X", ( buffer_snr[x]/buffer_count[x] ) );
		sprintf( temp_buffer2, "%04X", buffer_count[x] );

		msg_buffer[ char_pos++ ] = temp_buffer[ 0 ];
		msg_buffer[ char_pos++ ] = temp_buffer[ 1 ];
		msg_buffer[ char_pos++ ] = temp_buffer[ 2 ];
		msg_buffer[ char_pos++ ] = temp_buffer[ 3 ];
		msg_buffer[ char_pos++ ] = temp_buffer[ 4 ];
		msg_buffer[ char_pos++ ] = temp_buffer[ 5 ];
#ifndef SIGFOX
		msg_buffer[ char_pos++ ] = temp_buffer1[ 0 ];
		msg_buffer[ char_pos++ ] = temp_buffer1[ 1 ];
		msg_buffer[ char_pos++ ] = temp_buffer2[ 0 ];
		msg_buffer[ char_pos++ ] = temp_buffer2[ 1 ];
		msg_buffer[ char_pos++ ] = temp_buffer2[ 2 ];
		msg_buffer[ char_pos++ ] = temp_buffer2[ 3 ];
#endif
	}

	msg_buffer[ char_pos ] = '\0';

	send_multibyte_msgs( msg_buffer, strlen( msg_buffer ) );
}

void send_msg_park( uint8_t x_status, uint8_t y_status, uint8_t z_status, uint8_t total_status,  uint8_t park, uint8_t power  )
{
	uint8_t msg = 0b00000000;

	msg |= park;
	msg |= x_status << 1;
	msg |= y_status << 2;
	msg |= z_status << 3;
	msg |= total_status << 4;
	msg |= ( MSG_ID_PARK_TEMPERATURE ) << 5;

	char hex[2];
	dataToHex(hex, msg);

	send_msg( hex, power );
}


void send_msg_batt( uint8_t stav_batt, uint8_t park, uint8_t power )
{
	uint8_t msg = 0b00000000;
	msg |= ( stav_batt & 0b00001111 ) << 1;
	msg |= ( park & 0b00000001 );
	msg |= ( MSG_ID_PARK_BATT ) << 5;

	char hex[2];
	dataToHex(hex, msg);

	if ( transmisson_mode == 1 ) {
		char buffer[ 150 ];
		buffer[0] = hex[0];
		buffer[1] = hex[1];
		buffer[2] = 0;
		buffer[3] = 0;

		for( int x = 4; x < 100;x+=4 ) {
			sprintf( buffer+x, "%04X", buffer[ x/4 ] );
			buffer[ 100 ] = 0;
		}
		send_multibyte_msg( buffer, 100, 0 );
		a_buffer_pos = 0;
	}else{
		send_msg( hex, power );

	}
}

void send_msg_laird_version( uint32_t version ) {
	char buffer[ 50 ];
	sprintf(buffer, "%08X", version);
	/*
	char temp_buffer[ 40 ];

	if ( strlen( buffer ) < 8 ) {

		for( int x = 0; x < ( 8 - strlen( buffer ) ); x++ ) {
			temp_buffer[ x ] = '0';
		}

		for( int x = 0; x < ( strlen( buffer ) ); x++ ) {
			temp_buffer[ ( 8 - strlen( buffer ) ) + x ] = buffer[ x ];
		}


	}
	*/
	send_multibyte_msg( buffer, strlen( buffer ), 1 );
}


void send_msg_baseline() {
	char buffer[ 50 ];
	sprintf(buffer, "%04X%04X%04X%04X%04X", data_x.b_old, data_rotation.b_old, data_mag.b_old, data_total.b_old, data_mag_total.b_old);
	/*
	char temp_buffer[ 40 ];

	if ( strlen( buffer ) < 8 ) {

		for( int x = 0; x < ( 8 - strlen( buffer ) ); x++ ) {
			temp_buffer[ x ] = '0';
		}

		for( int x = 0; x < ( strlen( buffer ) ); x++ ) {
			temp_buffer[ ( 8 - strlen( buffer ) ) + x ] = buffer[ x ];
		}


	}
	*/
	send_multibyte_msg( buffer, strlen( buffer ), 1 );
}

void send_msg_baseline_offset( uint16_t baseline, uint16_t offset_x, uint16_t offset_y, uint16_t offset_z ) {
	char buffer[ 50 ];
	sprintf(buffer, "%04X%04X%04X%04X", baseline, abs( offset_x ), abs( offset_y ), abs( offset_z ) );
	/*
	char temp_buffer[ 40 ];

	if ( strlen( buffer ) < 8 ) {

		for( int x = 0; x < ( 8 - strlen( buffer ) ); x++ ) {
			temp_buffer[ x ] = '0';
		}

		for( int x = 0; x < ( strlen( buffer ) ); x++ ) {
			temp_buffer[ ( 8 - strlen( buffer ) ) + x ] = buffer[ x ];
		}


	}
	*/
	send_multibyte_msg( buffer, strlen( buffer ), 1 );
}


void send_msg_temp_l( uint8_t temperature, uint8_t park, uint8_t power, int16_t diff)
{
	uint8_t msg = 0b00000000;
	msg |= ( temperature & 0b00001111 ) << 1;
	msg |= ( park & 0b00000001 );
	msg |= ( MSG_ID_PARK_TEMPERATURE ) << 5;

	char hex[2];
	dataToHex(hex, msg);
	char buffer[ 50 ];
	char buffer1[ 50 ];
	char buffer2[ 50 ];

	buffer[0] = hex[0];
	buffer[1] = hex[1];

	itoa( diff, buffer1, 16 );
	stuffByte( buffer1, buffer2 );

	buffer[2] = buffer2[0];
	buffer[3] = buffer2[1];
	buffer[4] = buffer2[2];
	buffer[5] = buffer2[3];
	buffer[6] = 0;
	radio_on();
	HAL_Delay( 25 );
	radio_set_power( POWER_20 );
	HAL_Delay( 100 );
	char temp_buffer[ 100 ];

	radio_send_multibyte_msg( buffer, strlen( buffer ) / 2 , 1, 0 );

	//send_msg( hex, power );
}

//#define TO_HEX(i) (i <= 9 ? '0' + i : 'A' - 10 + i)

void send_msg_radar_sweep_debug( char * sweep_data ) {
	char buffer[ 100 ];
	buffer[ 0 ] = '4';
	buffer[ 1 ] = '0';
	buffer[ 2 ] = '0';
	buffer[ 3 ] = '3';
	char temp_buffer[ 20 ];

	uint8_t pos = 4;

	for( uint8_t x = 4; x < 83; x+=8 ) {
		sprintf( temp_buffer, "%02X%02X%02X%02X", sweep_data[( (x-4)/2 )], sweep_data[( (x-4)/2 )+1], sweep_data[ ( (x-4)/2 )+2 ], sweep_data[ ( (x-4)/2 )+3 ] );




		buffer[ x ] = temp_buffer[ 0 ];
		buffer[ x + 1 ] = temp_buffer[ 1 ];
		buffer[ x + 2 ] = temp_buffer[ 2 ];
		buffer[ x + 3 ] = temp_buffer[ 3 ];
		buffer[ x + 4 ] = temp_buffer[ 4 ];
		buffer[ x + 5 ] = temp_buffer[ 5 ];
		buffer[ x + 6 ] = temp_buffer[ 6 ];
		buffer[ x + 7 ] = temp_buffer[ 7 ];


		pos = pos + 8;
	}


	buffer[ pos ] = 0;

	send_multibyte_msg( buffer, strlen( buffer ), 0 );

}

void send_msg_temp( uint8_t x, uint8_t y, uint8_t z,uint8_t total, uint8_t park, uint8_t power)
{
	uint8_t msg = 0b00000000;

	msg |= park;
	msg |= x << 1;
	msg |= y << 2;
	msg |= z << 3;
	msg |= total << 4;
	msg |= ( MSG_ID_PARK_TEMPERATURE ) << 5;

	char hex[2];
	dataToHex(hex, msg);

	if ( transmisson_mode == 1 ) {

		char buffer[ 150 ];
		buffer[0] = hex[0];
		buffer[1] = hex[1];
		buffer[2] = '0';
		buffer[3] = '1';
		char temp_buffer[ 20 ];
		for( int x = 4; x < 100;x+=4 ) {
			sprintf( temp_buffer, "%08X", a_buffer[ (x-4)/4 ] );

			buffer[ x ] = temp_buffer[ 4 ];
			buffer[ x + 1 ] = temp_buffer[ 5 ];
			buffer[ x + 2 ] = temp_buffer[ 6 ];
			buffer[ x + 3 ] = temp_buffer[ 7 ];


/*
			int16_t x_specific = a_buffer[ (x-4)/4 ];

			buffer[x] = TO_HEX(((x_specific & 0xF000) >> 12));
			buffer[x + 1] = TO_HEX(((x_specific & 0x0F00) >> 8));
			buffer[x + 2] = TO_HEX(((x_specific & 0x00F0) >> 4));
			buffer[x + 3] = TO_HEX((x_specific & 0x000F));
*/
		}
		buffer[ 100 ] = 0;

		send_multibyte_msg( buffer, 100, 0 );
		a_buffer_pos = 0;

	}else{
		send_msg( hex, power );

	}

}

uint8_t frame_count() {
	if ( total_msg_count >= MSG_LIMITS ) {
		return CANT_SEND;
	}else if ( total_msg_count == ( MSG_LIMITS - 1 ) ){
		total_msg_count++;
		return LAST_SEND;
	}else{
		total_msg_count++;
		return CAN_SEND;
	}

}

void frame_count_reset() {
	total_msg_count = 0;
}

void send_msg_car_conut( uint16_t car_count )
{
	uint8_t msg = 0b00000000;
	msg |= ( car_count & 0b00011111 );
	msg |= ( MSG_ID_CAR_COUNT ) << 5;

	char hex[2];
	dataToHex(hex, msg);

	send_msg( hex, POWER_20 );
}


void send_msg_err( uint8_t mag_err, uint8_t batt_err, uint8_t photo_err, uint8_t wdog, uint8_t bootloader, uint8_t wdog_reason, uint8_t bootloader_reason, uint8_t last_action_before_rst )
{
	uint8_t msg = 0b00000000;

	msg |= ( mag_err & 0b00000001 );
	msg |= ( batt_err & 0b00000001 ) << 1;
	msg |= ( photo_err & 0b00000001 ) << 2;
	msg |= ( wdog & 0b00000001 ) << 3;
	msg |= ( bootloader & 0b00000001 ) << 4;

	msg |= ( MSG_ID_ERR ) << 5;

	char hex[2];
	dataToHex(hex, msg);

	char buffer[ 10 ];
	if ( wdog == 1 ) {
		sprintf( buffer, "%02X%02X%02X", msg, wdog_reason, last_action_before_rst );
		send_multibyte_msgs( buffer, 4 );
	}else if ( bootloader == 1 ) {

		sprintf( buffer, "%02X%02X", msg, bootloader_reason );
		send_multibyte_msgs( buffer, 4 );

	}else{
		send_msg( hex, POWER_20 );

	}

}


