/*
 * parking_msgs.h
 *
 *  Created on: Sep 19, 2017
 *      Author: fiala
 */

#ifndef PARKING_MSGS_H_
#define PARKING_MSGS_H_

#include "main.h"
#include "usart.h"

#include <stdio.h>
#include <stdlib.h>

#define 	MSG_ID_START			0
#define 	MSG_ID_PARK_BATT		1
#define 	MSG_ID_PARK_TEMPERATURE	2
#define 	MSG_ID_NETWORK		    3
#define 	MSG_ID_CAR_COUNT		4
#define 	MSG_ID_LAID_BOOTLAODER	5
#define 	MSG_ID_PARK_BOOTLOADER	6
#define 	MSG_ID_ERR				7


#ifdef MURATA
	#define MSG_LIMITS 3000
#endif

#ifdef SIGFOX
	#define MSG_LIMITS 144
#endif

#define CAN_SEND 0
#define CANT_SEND 1
#define LAST_SEND 2


void send_msg_batt( uint8_t stav_batt, uint8_t park, uint8_t power );
void send_msg_temp(  uint8_t x, uint8_t y, uint8_t z,uint8_t total, uint8_t park, uint8_t power );
void send_msg_car_conut( uint16_t car_count );
void send_msg_park( uint8_t x_status, uint8_t y_status, uint8_t z_status, uint8_t total_status, uint8_t park, uint8_t power  );
//void send_msg_oob( uint8_t frame_count);
void send_msg_reserved1( void );
void send_msg_err( uint8_t mag_err, uint8_t batt_err, uint8_t photo_err, uint8_t wdog, uint8_t bootloader, uint8_t wdog_reason, uint8_t bootloader_reason, uint8_t last_action_before_rst );
void send_msg_system( uint8_t start_flag, uint8_t integration_flag, uint8_t wake_up_flag, uint8_t OK_FLAG, uint8_t version, uint8_t count, int16_t baseline, int16_t baseline1, int16_t baseline2, int16_t baseline3, int16_t baseline4, char * buff );
void send_msg_mag_field( int32_t bel, uint8_t park, uint8_t power );
void send_msg_baseline();
void send_msg_network( uint8_t mac_service, uint8_t OOB, uint8_t MSG_LIMIT );
//void send_msg_park_park( uint8_t stav_park);
void send_msg_system_recv( uint8_t OOB_flag, char * output_buffer );
uint8_t frame_count();
void frame_count_reset();
void send_msg_bootloader( uint8_t transfer_ok, uint8_t bootloader_failed, uint8_t half_complete, uint8_t entering_bootloader );
void send_msg_baseline_offset( uint16_t baseline, uint16_t offset_x, uint16_t offset_y, uint16_t offset_z );
void send_msg_bootloader_progress(  uint16_t packet_num );
void send_msg_id();
void send_msg_radar_sweep_debug( char * sweep_data );
void send_msg_version();
void send_msg_system_ok_confirmation( uint8_t code, uint8_t type, uint8_t crc );
void send_multibyte_msg( char * buffer, int len, uint8_t ignore_downlinks );
void send_multibyte_msgs( char * buffer, int len );

#endif /* PARKING_MSGS_H_ */
