/*
 * sd.c
 *
 *  Created on: Apr 13, 2018
 *      Author: Tomas
 */
#include "sd.h"

void sd_init() {
	HAL_GPIO_WritePin(SD_EN_GPIO, SD_EN, GPIO_PIN_SET);
	HAL_Delay( 100 );
	count_sd = 0;
	  SD_Start();
	HAL_GPIO_WritePin(SD_EN_GPIO, SD_EN, GPIO_PIN_RESET);
}

void sd_push() {
	count_sd++;

}

void sd_flush_to_card() {
	char data[ 500 ];
	for( int x = 0; x < count_sd; x++ ) {

/*
		sprintf( data, "%d, %d, %d, %d, %d, %d, %d\n", point_buffet[ x ].x, point_buffet[ x ].y, point_buffet[ x ].z, point_buffet[ x ].state, point_buffet[ x ].bellum, point_buffet[ x ].a );
		sd_write( "mer1.csv", data, strlen( data ) );
		*/
		HAL_Delay( 10 );

	}
	//HAL_GPIO_WritePin(SD_EN_GPIO, SD_EN, GPIO_PIN_RESET);
}

void sd_write_to_card( int16_t x, int16_t y, int16_t z, uint8_t state, int32_t bellum, int32_t a, int32_t diff ){

	char x_buff[ 50 ];
	char y_buff[ 50 ];
	char z_buff[ 50 ];
	char a_buff[ 50 ];
	char b_buff[ 50 ];
	char state_buff[ 50 ];
	char results[ 100 ];


    get_dec_str (x_buff, 6, x);
    get_dec_str (y_buff, 6, y);
    get_dec_str (z_buff, 6, z);
    get_dec_str (state_buff, 2, state);
    get_dec_str (a_buff, 6, a);
    get_dec_str (b_buff, 6, bellum);

    memcpy( results, x_buff, 6 );
    memcpy( results+6, ",", 1 );
    memcpy( results+7, y_buff, 6 );
    memcpy( results+13, ",", 1 );
    memcpy( results+14, z_buff, 6 );
    memcpy( results+20, ",", 1 );
    memcpy( results+21, state_buff, 2 );
    //memcpy( results+23, ",", 1 );
    memcpy( results+23, "\n", 1 );

    results[ 24 ] = '\0';
    memcpy( sd_buffer + sd_buffer_pos, results, 24 );
    sd_buffer_pos = sd_buffer_pos + 24;




    if ( sd_buffer_pos > 2500 ) {
    	MX_SPI1_Init();
    	HAL_Delay( 500 );
    	//HAL_GPIO_WritePin(BT_RST_GPIO_Port, BT_RST_Pin, GPIO_PIN_SET);
    	HAL_Delay( 500 );

    	SD_Start();
    	HAL_Delay( 500 );

    	res = f_open(&MyFile, "mer1.csv", 	FA_OPEN_APPEND | FA_WRITE | FA_READ );
		res = f_sync(&MyFile);
		//FileSize = f_size(&MyFile);
		//res = f_lseek(&MyFile,FileSize);
		res = f_write(&MyFile, sd_buffer, sd_buffer_pos, (void *)&byteswritten);
		res = f_sync(&MyFile);
		f_close( &MyFile );
		res = f_mount(0,  (TCHAR const*)SDPath, 0);
		FATFS_UnLinkDriverEx( SDPath, 0 );
		sd_buffer_pos = 0;
		HAL_Delay( 500 );
    	//HAL_GPIO_WritePin(BT_RST_GPIO_Port, BT_RST_Pin, GPIO_PIN_RESET);
    	HAL_SPI_DeInit( &hspi1 );
    }



}

void sd_write( char * filename, char * data, uint16_t len ) {

	  //SD_Start();
	res = f_open(&MyFile, filename, FA_WRITE | FA_OPEN_APPEND);
	res = f_sync(&MyFile);
	FileSize = f_size(&MyFile);
	res = f_lseek(&MyFile,FileSize);
	res = f_write(&MyFile, data, len, (void *)&byteswritten);
	f_close(&MyFile);
}

void SD_Start(void){
	  FRESULT res;

	  res = FATFS_LinkDriver(&SD_Driver, SDPath);
	  res = f_mount(&SDFatFs, (TCHAR const*)SDPath, 1);
}
