/*
 * sigfox.c
 *
 *  Created on: Mar 9, 2018
 *      Author: Tomas
 */
#include "sigfox.h"

void sigfox_UART_Init(void)
{
	MX_DMA_Init();

	HAL_NVIC_SetPriority(DMA1_Channel4_5_6_7_IRQn, 0, 0);
	HAL_NVIC_EnableIRQ(DMA1_Channel4_5_6_7_IRQn);

	MX_USART2_UART_Init( 9600 );
	uartRxBuffInit();
	while( HAL_UART_Receive_DMA(&huart2, rxData, 2 ) != HAL_OK)
		HAL_UART_Transmit( &huart2, "DMA buff not set!\n" , strlen("DMA buff not set!\n"), 1000);

}

void sigfox_on( void )
{
	sigfox_UART_Init();

	HAL_GPIO_WritePin(BOOST_EN_Port, BOOST_EN_Pin, GPIO_PIN_SET);
	HAL_Delay( 10 );
	HAL_GPIO_WritePin(RM_EN_Port, RM_EN_Pin, GPIO_PIN_SET);
	HAL_Delay( 10 );
	HAL_GPIO_WritePin( RM_NRST_GPIO_Port, RM_NRST_Pin, GPIO_PIN_SET );
	HAL_Delay( 10 );


	findMatchNonblocking( "SIGFOX", 6, 8000 );

}

uint8_t sigfox_send( char * command ) {
	HAL_UART_Transmit( &huart2, "\r", 1, DEFAULT_UART_TIMEOUT );
	HAL_Delay( 25 );
	uartRxBuffClear();
	HAL_UART_Transmit( &huart2, command, strlen( command ), DEFAULT_UART_TIMEOUT );
	return findMatchNonblocking("OK", 2, 8000);

}
void sigfox_get_provisioning() {
	uartRxBuffClear();
	HAL_UART_Transmit( &huart2, "ATS302=20\r" , strlen("ATS302=20\r"), 1000);
	HAL_Delay( 100 );

	uint8_t position ;
	if ( findMatchNonblockingPos( "OK", 2, 4000, &position ) == 1 ) {

	}else{
		for( uint8_t x = 0; x < ID_SIZE; x+=1 ) {
			un_device_id[ x ] = x;
		}
		sigfox_off();
		return;
	}


	uartRxBuffClear();
	HAL_UART_Transmit( &huart2, "AT$PAC\r" , strlen("AT$PAC\r"), 1000);
	HAL_Delay( 25 );
	uartRxBuffClear();
	HAL_UART_Transmit( &huart2, "AT$ID\r" , strlen("AT$ID\r"), 1000);
	HAL_Delay( 100 );
	char hex[4];

	uint8_t pos = 0;
	uint8_t offset = 0;
	uint8_t end_s = 0;


	for( uint8_t x = 0; x < 20; x++ ) {
		if ( uartRxBuff.data[ x ] == '\n' && offset == 0 ) {
			offset = x + 1;
		}

		if ( uartRxBuff.data[ x ] == '\r' && offset != 0 && end_s == 0) {
			end_s = x;
		}

	}


	uint8_t total_len = end_s - offset;

	for( uint8_t x = offset; x < (total_len+offset); x+=2 ) {
		hex[0] = uartRxBuff.data[ x ];
		hex[1] = uartRxBuff.data[ x + 1 ];

		un_device_id[ (pos) ] = strtol( hex, NULL, 16 );
		pos++;
	}



	HAL_Delay( 25 );
	HAL_Delay( 25 );

}

uint16_t sigfox_frame_counter1 = 0;

uint8_t sigfox_frame_counter() {
	if ( sigfox_frame_counter1 < 160 ) {
		sigfox_frame_counter1++;
	}
}

uint8_t sigfox_recv_msg() {
	uint8_t v = 0;
	char msg_radio[14] = "\rAT$SF=xx,1\r\0";
	memcpy(msg_radio+7, "61", 2);
	HAL_UART_Transmit( &huart2, "\r", 1, DEFAULT_UART_TIMEOUT );
	HAL_Delay( 25 );
	uartRxBuffInit();
	HAL_UART_Transmit( &huart2, msg_radio, strlen( msg_radio ), DEFAULT_UART_TIMEOUT );


	uint16_t pos;
	if ( findMatchNonblockingPos("+RX", 3, 120000, &pos) == 0 ) {
	}else{

		uartRxBuffRead();
		uartRxBuffRead();
		uartRxBuffRead();
		uartRxBuffRead();
		uartRxBuffRead();
		uartRxBuffRead();

		uint8_t gg[ 8 ];

		gg[0] = uartRxBuffRead();


		if ( gg[0] == RESTART_MSG ) {
			asm( "nop" );
			gg[1] = uartRxBuffRead();

			uint16_t in_number_of_hours = gg[1];

			//time_to_next_restart = (in_number_of_hours*3600)/DEFAULT_RTC_ALARM;
			HAL_NVIC_SystemReset();
			return gg[0];
		}else if ( gg[0] == SETTINGS_MSG ) {
			asm( "nop" );

			gg[1] = uartRxBuffRead();
			gg[2] = uartRxBuffRead();

			gg[3] = uartRxBuffRead();
			gg[4] = uartRxBuffRead();

			gg[5] = uartRxBuffRead();
			gg[6] = uartRxBuffRead();
			gg[7] = uartRxBuffRead();

			uint16_t ths1 = ( gg[1] << 8 ) + gg[2]; // stop integracii
			uint16_t ths2 = ( gg[3] << 8 ) + gg[4]; // enterring flux
			uint16_t thsUP = ( gg[5] << 8 ) + gg[6]; // r flux
			uint16_t alpha = gg[7];



			if ( thsUP != NO_CHANGE )
				data_x.threshold_up = thsUP;


			if ( ths1 != NO_CHANGE )
				data_x.threshold_intg  = ths1;

			if ( alpha != NO_CHANGE )
				data_x.alpha = alpha;

			return gg[0];
		}else if ( gg[0] == SETTINGS_MSG1 ) {
			asm( "nop" );

			gg[1] = uartRxBuffRead();
			gg[2] = uartRxBuffRead();

			gg[3] = uartRxBuffRead();
			gg[4] = uartRxBuffRead();

			gg[5] = uartRxBuffRead();
			gg[6] = uartRxBuffRead();
			gg[7] = uartRxBuffRead();

			uint16_t thsDOWN = ( gg[1] << 8 ) + gg[2]; // stop integracii
			uint16_t thsBLW = ( gg[3] << 8 ) + gg[4]; // enterring flux
			uint16_t remove_threshold = ( gg[5] << 8 ) + gg[6]; // r flux
			uint16_t buffer_size = gg[7];

			if ( thsDOWN != NO_CHANGE )
				data_x.threshold_down = thsDOWN;



			if ( buffer_size != NO_CHANGE )
				data_x.buffer_size  = buffer_size;


			return gg[0];
		}else if ( gg[0] == SETTINGS_MSG2 ) {
			asm( "nop" );

			gg[1] = uartRxBuffRead();
			gg[2] = uartRxBuffRead();

			gg[3] = uartRxBuffRead();
			gg[4] = uartRxBuffRead();

			gg[5] = uartRxBuffRead();
			gg[6] = uartRxBuffRead();

			gg[7] = uartRxBuffRead();

			uint16_t main_counter_threshold = ( gg[1] << 8 ) + gg[2]; // stop integracii
			uint16_t warm_up_time = ( gg[3] << 8 ) + gg[4]; // enterring flux
			uint16_t threshold_delimeter = ( gg[5] << 8 ) + gg[6]; // r flux
			uint16_t ent_flx_count = gg[7];



			if ( main_counter_threshold != NO_CHANGE )
				data_x.main_counter_threshold = main_counter_threshold;

			if ( warm_up_time != NO_CHANGE )
				data_x.warm_up_time = warm_up_time;

			return gg[0];
		}else if ( gg[0] == SETTINGS_MSG3 ) {
			asm( "nop" );

			gg[1] = uartRxBuffRead();
			gg[2] = uartRxBuffRead();

			gg[3] = uartRxBuffRead();
			gg[4] = uartRxBuffRead();

			gg[5] = uartRxBuffRead();
			gg[6] = uartRxBuffRead();

			gg[7] = uartRxBuffRead();

			uint16_t s3_n_counter_threshold = gg[1];
			uint16_t s5_n_counter_threshold = gg[2];
			uint16_t s6_n_counter_threshold = gg[3];
			uint16_t s7_n_counter_threshold = gg[4];
			uint16_t s8_n_counter_threshold = gg[5];
			uint16_t change_max_val_devider_6_state = gg[6];


			if ( s3_n_counter_threshold != NO_CHANGE )
				data_x.s3_n_counter_threshold = s3_n_counter_threshold;

			if ( s5_n_counter_threshold != NO_CHANGE )
				data_x.s5_n_counter_threshold = s5_n_counter_threshold;

			if ( s6_n_counter_threshold != NO_CHANGE )
				data_x.s6_n_counter_threshold = s6_n_counter_threshold;

			return gg[0];
		}else if ( gg[0] == SETTINGS_MSG4 ) {
			asm( "nop" );

			gg[1] = uartRxBuffRead();
			gg[2] = uartRxBuffRead();

			gg[3] = uartRxBuffRead();
			gg[4] = uartRxBuffRead();

			gg[5] = uartRxBuffRead();
			gg[6] = uartRxBuffRead();

			gg[7] = uartRxBuffRead();

			uint16_t thsDOWN = ( gg[1] << 8 ) + gg[2]; // stop integracii
			uint16_t thsBLW = ( gg[3] << 8 ) + gg[4]; // enterring flux

			if ( thsDOWN != NO_CHANGE )
				data_mag.threshold_down = thsDOWN;

			if ( thsBLW != NO_CHANGE )
				data_mag.threshold_up = thsBLW;


			return gg[0];
		}else if ( gg[0] == SETTINGS_MSG5 ) {
			asm( "nop" );

			gg[1] = uartRxBuffRead();
			gg[2] = uartRxBuffRead();

			gg[3] = uartRxBuffRead();
			gg[4] = uartRxBuffRead();

			gg[5] = uartRxBuffRead();
			gg[6] = uartRxBuffRead();

			gg[7] = uartRxBuffRead();

			uint16_t thsDOWN = ( gg[1] << 8 ) + gg[2]; // stop integracii
			uint16_t thsBLW = ( gg[3] << 8 ) + gg[4]; // enterring flux

			if ( thsDOWN != NO_CHANGE )
				data_rotation.threshold_down = thsDOWN;

			if ( thsBLW != NO_CHANGE )
				data_rotation.threshold_up = thsBLW;


			return gg[0];
		}else if ( gg[0] == BASELINE_MSG ) {

			asm( "nop" );
			gg[1] = uartRxBuffRead();
			gg[2] = uartRxBuffRead();
			gg[3] = uartRxBuffRead();
			gg[4] = uartRxBuffRead();



			int32_t baseline = ( gg[1] << 24 ) + ( gg[2] << 16 ) + ( gg[3] << 8 ) + gg[4];

			data_x.b_old = baseline;
			data_x.bellum = baseline;
			return gg[0];
		}else if ( gg[0] == KA_SETTINGS ) {

			gg[1] = uartRxBuffRead();
			gg[2] = uartRxBuffRead();

			gg[3] = uartRxBuffRead();
			gg[4] = uartRxBuffRead();

			gg[5] = uartRxBuffRead();
			gg[6] = uartRxBuffRead();
			gg[7] = uartRxBuffRead();

			uint32_t time = ( gg[1] << 24 ) + ( gg[2] << 16 ) + ( gg[3] << 8 ) + gg[4];
			uint32_t n_of_repetition_msg = gg[5];
			uint8_t use_temp_stap = gg[6];



			if ( time != 0 ) {
				max_idle_periods = time / MAGNETOMETER_TIME_CONSTANT;
			}

			if ( n_of_repetition_msg != 0 ) {
				number_of_msg_repetition = n_of_repetition_msg;
			}
			if ( use_temp_stap != 0 ) {
				use_temp_offset_calc = use_temp_stap;
				data_x.state = 1;
				data_x.main_counter = 0;
				old_state = 1;
			}
			return gg[0];
		}else if ( gg[0] == BOOTLOADER_MSG ) {

			gg[1] = uartRxBuffRead();
			gg[2] = uartRxBuffRead();

			gg[3] = uartRxBuffRead();
			gg[4] = uartRxBuffRead();

			gg[5] = uartRxBuffRead();
			gg[6] = uartRxBuffRead();

			gg[7] = uartRxBuffRead();

			uint8_t state = gg[1];
			uint8_t use_light = gg[2];


			if ( state == 1 && nrf_mode != NRF_MODE )
				nrf_startup = state;

			if ( state == NRF_MODE) {
				if ( use_light == 1 ) {

					pht_ons_data = 1;
				}
				nrf_startup = 1;
			}

			if ( state == 0 )
				nrf_startup = 99;

			if ( state == 10 && nrf_mode != NRF_MODE && nrf_mode != NRF_LAIRD_MODE ) {
				nrf_startup = 10;
			}
			return gg[0];
		}else{
			asm( "nop" );


		}

	}


	//HAL_UART_Transmit( &huart2, "AT$PAC\r" , strlen("AT$PAC\r"), 1000);
	return 0;
}

void sigfox_init() {

	sigfox_on();
	HAL_Delay( 100 );
	HAL_UART_Transmit( &huart2, "\r" , strlen("\r"), 1000);
	HAL_Delay( 100 );
#ifdef AMERICA
	HAL_UART_Transmit( &huart2, "AT$RCZ=2\r" , strlen("AT$RC=2\r"), 1000);
#else
	HAL_UART_Transmit( &huart2, "AT$RCZ=1\r" , strlen("AT$RC=1\r"), 1000);

#endif
	HAL_Delay( 200 );
	HAL_UART_Transmit( &huart2, "\r" , strlen("\r"), 1000);
	HAL_Delay( 200 );
	sigfox_get_provisioning();
	sigfox_off();


}

void sigfox_off( void )
{
	if (  nrf_mode != NRF_MODE ) {
		HAL_GPIO_WritePin(BOOST_EN_Port, BOOST_EN_Pin, GPIO_PIN_RESET);
	}
	HAL_GPIO_WritePin( RM_EN_Port, RM_EN_Pin, GPIO_PIN_RESET);
	HAL_GPIO_WritePin( RM_NRST_GPIO_Port, RM_NRST_Pin, GPIO_PIN_RESET );

	HAL_UART_DeInit(&huart2);


	  HAL_NVIC_DisableIRQ(DMA1_Channel4_5_6_7_IRQn);
	  HAL_NVIC_DisableIRQ(DMA1_Channel2_3_IRQn);


	  HAL_GPIO_DeInit( MCU_RX_GPIO_Port, MCU_RX_Pin );

	  HAL_GPIO_DeInit( MCU_RX_GPIO_Port, MCU_TX_Pin );



}
