/*
 * uartRxBuff.c
 *
 *  Created on: May 25, 2017
 *      Author: fiala
 */
#include "uartRxBuff.h"

struct uartRxBuff_t uartRxBuff;
struct uartRxBuff_t uartRxBuff2;
extern UART_HandleTypeDef huart_radio;

void uartRxBuffInit(void)
{
	uartRxBuff.end = 0;
	uartRxBuff.start = 0;
}


void uartRxBuff2Init(void)
{
	uartRxBuff2.end = 0;
	uartRxBuff2.start = 0;
}

void uartRxBuffClear(void)
{
	uartRxBuffInit();
}

void uartRxBuff2Clear(void)
{
	uartRxBuff2Init();
}

void uartRxBuffWrite(uint8_t data)
{
	uartRxBuff.data[uartRxBuff.end] = data;
	uartRxBuff.end += 1;
	uartRxBuff.end = uartRxBuff.end % UART_RX_BUFF_SIZE;
}

void uartRxBuff2Write(uint8_t data)
{
	uartRxBuff2.data[uartRxBuff2.end] = data;
	uartRxBuff2.end += 1;
	uartRxBuff2.end = uartRxBuff2.end % UART_RX_BUFF_SIZE;
}

void shiftBufferToPosition( uint8_t new_start ) {
	uartRxBuff.start = new_start;
}

uint8_t uartRxBuffRead()
{
	uint8_t data = uartRxBuff.data[uartRxBuff.start];
	uartRxBuff.start += 1;
	uartRxBuff.start = uartRxBuff.start % UART_RX_BUFF_SIZE;
	return data;
}

uint8_t uartRxBuffIsEmpty() {

	if ( uartRxBuff.start == uartRxBuff.end ) {
		return 0;
	}
	return 1;
}

uint8_t uartRxBuff2Read()
{
	uint8_t data = uartRxBuff2.data[uartRxBuff2.start];
	uartRxBuff2.start += 1;
	uartRxBuff2.start = uartRxBuff2.start % UART_RX_BUFF_SIZE;
	return data;
}

int32_t uartRxRead4Data( uint8_t pos ) {
	uint16_t baseline1 = uartRxReadData( pos, 2 );
	uint16_t baseline2 = uartRxReadData( pos, 2 );

	int32_t baseline = ( baseline1 << 16 ) + baseline2;

	return baseline;

}


uint16_t uartRxReadData( uint8_t pos, uint8_t size ) {
	char ff[ 25 ];

	for ( uint8_t x = 0; x < size*2; x++ ) {

		ff[ x ] = uartRxBuffRead();

	}
	ff[ size*2 ] = 0;

	char *ptr;

	uint16_t data = strtol( ff, ptr, 16 );

	return data;

}


uint8_t * uartRxBuffGetStart()
{
	return &uartRxBuff.data[uartRxBuff.start];
}

uint8_t uartRxBuffGetUsedSize2()
{	if(uartRxBuff2.end >= uartRxBuff2.start)
		return( uartRxBuff2.end - uartRxBuff2.start );
	else
		return( UART_RX_BUFF_SIZE - uartRxBuff2.end + uartRxBuff2.start);
}


uint8_t uartRxBuffGetUsedSize()
{	if(uartRxBuff.end >= uartRxBuff.start)
		return( uartRxBuff.end - uartRxBuff.start );
	else
		return( UART_RX_BUFF_SIZE - uartRxBuff.end + uartRxBuff.start);
}

uint8_t compareResponse(uint8_t * expect, uint8_t exp_len, uint8_t * compare, uint8_t cmp_len, uint8_t * match_position )
{
	//HAL_UART_Transmit( &huart2, expect ,  exp_len, 1000);
	//HAL_UART_Transmit( &huart2, "\n" , 1, 1000);

	uint8_t equal = 0;
	if(exp_len > cmp_len)
	{
		//uartRxBuff.start = (uartRxBuff.start + cmp_len) % UART_RX_BUFF_SIZE;
		return 0;
	}
	uint8_t i;

	for(i = 0; i < cmp_len; i++)
	{
		HAL_IWDG_Refresh( &hiwdg );
		if(expect[0] == compare[ i % UART_RX_BUFF_SIZE ]) //character matches with first character of expectation
		{
			if( cmp_len-i < exp_len) //compared is shorter than expected
			{
				//uartRxBuff.start = (uartRxBuff.start + cmp_len) % UART_RX_BUFF_SIZE;
				return 0;
			}
			equal = 1;
			uint8_t j;
			for(j = 0; j < exp_len; j++)
			{
				if(expect[j] != compare[ (j+i) % UART_RX_BUFF_SIZE ] ) //compare other chatacters
				{
					equal = 0;
					break;
				}
			}
			if(equal == 1)
			{
				found_match_position = i;
				//uartRxBuff.start = (uartRxBuff.start + cmp_len) % UART_RX_BUFF_SIZE;
				return 1;
			}
		}
	}
	//uartRxBuff.start = (uartRxBuff.start + cmp_len) % UART_RX_BUFF_SIZE;
	return 0;
}


uint8_t findMatchBlocking(uint8_t * expect, uint8_t exp_len) //prerobit na blocking version
{
	uint8_t match = 0;
	while(match == 0)
	{
		//while(rxFlag == 0)
		while(0)
		{
			//HAL_PWR_EnterSTOPMode(PWR_LOWPOWERREGULATOR_ON, PWR_SLEEPENTRY_WFI);

		}
		/*
		uint8_t val_str[128];
		uint8_t size = uartRxBuffGetUsedSize();
		for( int i = 0; i < size ; i++)
		{
			val_str[i] = uartRxBuffRead();
		}
		HAL_UART_Transmit( &huart2, val_str , size, 1000);
		HAL_UART_Transmit( &huart2, "\n" , 1, 1000);
		*/

		uint8_t match_position;
		match =  compareResponse(expect, exp_len, &uartRxBuff.data[uartRxBuff.start], uartRxBuffGetUsedSize(), &match_position);
		HAL_IWDG_Refresh( &hiwdg );
		uartRxBuff.start = (uartRxBuff.start + uartRxBuffGetUsedSize()) % UART_RX_BUFF_SIZE;


	}
	return match;
}

uint8_t findMatchNonblockingPos(uint8_t * expect, uint8_t exp_len, uint32_t timeout, uint8_t pos )
// searches for expect string in uartRxBuff
// returns 1 on match, else returns 0
// buffer clearing is manual
{
	uint8_t match = 0;

	uint32_t tickstart = 0x00U;
	tickstart = HAL_GetTick();

	do
	{
		//if(rxFlag == 1)
		{
			/*
			uint8_t size = uartRxBuffGetUsedSize();
			uint8_t data[size];
			for( uint8_t i = 0; i < size; i++)
				data[i] = uartRxBuffRead();

			HAL_UART_Transmit( &huart2, data , size, 1000);
			*/

			match = compareResponse(expect, exp_len, &uartRxBuff.data[uartRxBuff.start], uartRxBuffGetUsedSize(), &pos);
			if(match == 1)
			{
				//HAL_UART_Transmit( &huart_radio, "match!\n" , strlen("match!\n"), 1000);
				//uartRxBuff.start = (uartRxBuff.start + uartRxBuffGetUsedSize()) % UART_RX_BUFF_SIZE;
				break;
			}
			HAL_IWDG_Refresh( &hiwdg );
			//HAL_UART_Transmit( &huart_radio, "Rx captured\n" , strlen("Rx captured\n"), 1000);
		}
		magneticDelay( 100 );
	}
	while( (HAL_GetTick() - tickstart) < timeout );

	//HAL_UART_Transmit( &huart_radio, "\nBuff: " , strlen("\nBuff: "), 1000);
//	HAL_UART_Transmit( &huart_radio, uartRxBuff.data[ uartRxBuff.start ] , uartRxBuffGetUsedSize() , 1000);
//	HAL_UART_Transmit( &huart_radio, "\nno match, exiting\n" , strlen("\nno match, exiting\n"), 1000);
//	uartRxBuff.start = (uartRxBuff.start + uartRxBuffGetUsedSize()) % UART_RX_BUFF_SIZE;
	return match;
}


uint8_t findMatchNonblockingPos2(uint8_t * expect, uint8_t exp_len, uint32_t timeout, uint8_t pos )
// searches for expect string in uartRxBuff
// returns 1 on match, else returns 0
// buffer clearing is manual
{
	uint8_t match = 0;

	uint32_t tickstart = 0x00U;
	tickstart = HAL_GetTick();

	do
	{
		//if(rxFlag == 1)
		{
			/*
			uint8_t size = uartRxBuffGetUsedSize();
			uint8_t data[size];
			for( uint8_t i = 0; i < size; i++)
				data[i] = uartRxBuffRead();

			HAL_UART_Transmit( &huart2, data , size, 1000);
			*/

			match = compareResponse(expect, exp_len, &uartRxBuff2.data[uartRxBuff2.start], uartRxBuffGetUsedSize2(), &pos);
			if(match == 1)
			{
				//HAL_UART_Transmit( &huart_radio, "match!\n" , strlen("match!\n"), 1000);
				//uartRxBuff.start = (uartRxBuff.start + uartRxBuffGetUsedSize()) % UART_RX_BUFF_SIZE;
				break;
			}
			HAL_IWDG_Refresh( &hiwdg );
			//HAL_UART_Transmit( &huart_radio, "Rx captured\n" , strlen("Rx captured\n"), 1000);
		}
		magneticDelay( 10 );
	}
	while( (HAL_GetTick() - tickstart) < timeout );

	//HAL_UART_Transmit( &huart_radio, "\nBuff: " , strlen("\nBuff: "), 1000);
//	HAL_UART_Transmit( &huart_radio, uartRxBuff.data[ uartRxBuff.start ] , uartRxBuffGetUsedSize() , 1000);
//	HAL_UART_Transmit( &huart_radio, "\nno match, exiting\n" , strlen("\nno match, exiting\n"), 1000);
//	uartRxBuff.start = (uartRxBuff.start + uartRxBuffGetUsedSize()) % UART_RX_BUFF_SIZE;
	return match;
}
uint8_t findMatchNonblocking(uint8_t * expect, uint8_t exp_len, uint32_t timeout )
// searches for expect string in uartRxBuff
// returns 1 on match, else returns 0
// buffer clearing is manual
{
	uint8_t match = 0;
	uint8_t match_position;

	uint32_t tickstart = 0x00U;
	tickstart = HAL_GetTick();

	do
	{
		//if(rxFlag == 1)
		{
			/*
			uint8_t size = uartRxBuffGetUsedSize();
			uint8_t data[size];
			for( uint8_t i = 0; i < size; i++)
				data[i] = uartRxBuffRead();

			HAL_UART_Transmit( &huart2, data , size, 1000);
			*/
			HAL_IWDG_Refresh( &hiwdg );
			match = compareResponse(expect, exp_len, &uartRxBuff.data[uartRxBuff.start], uartRxBuffGetUsedSize(), &match_position);
			if(match == 1)
			{
				//HAL_UART_Transmit( &huart_radio, "match!\n" , strlen("match!\n"), 1000);
				//uartRxBuff.start = (uartRxBuff.start + uartRxBuffGetUsedSize()) % UART_RX_BUFF_SIZE;
				break;
			}

			//HAL_UART_Transmit( &huart_radio, "Rx captured\n" , strlen("Rx captured\n"), 1000);
		}
		magneticDelay( 100 );
	}
	while( (HAL_GetTick() - tickstart) < timeout );

	//HAL_UART_Transmit( &huart_radio, "\nBuff: " , strlen("\nBuff: "), 1000);
//	HAL_UART_Transmit( &huart_radio, uartRxBuff.data[ uartRxBuff.start ] , uartRxBuffGetUsedSize() , 1000);
//	HAL_UART_Transmit( &huart_radio, "\nno match, exiting\n" , strlen("\nno match, exiting\n"), 1000);
//	uartRxBuff.start = (uartRxBuff.start + uartRxBuffGetUsedSize()) % UART_RX_BUFF_SIZE;
	return match;
}

uint8_t findMatchAndValueBlockingChar(uint8_t * expect, uint8_t exp_len, char * value, uint8_t value_start, uint8_t value_len, uint8_t value_format)
// returns true if match, value contains numeric value
// else returns false, value = 0
{

	uint8_t match_position;
	uint8_t match = compareResponse(expect, exp_len, &uartRxBuff.data[uartRxBuff.start], uartRxBuffGetUsedSize(), &match_position);
	if( match )
	{
		/*
		HAL_UART_Transmit( &huart2, "Match found. Position:", strlen("Match found. Position:"), 1000 );
		char string[5];
		get_dec_str(&string, 5, match_position);
		HAL_UART_Transmit( &huart2, string, 5, 1000 );
		HAL_UART_Transmit( &huart2, "\n", strlen("\n"), 1000 );
		*/
		// parse value starting at match position according to format
		uint8_t start_old = uartRxBuff.start;
		uartRxBuff.start = (uartRxBuff.start + value_start + match_position ) % UART_RX_BUFF_SIZE;
		HAL_IWDG_Refresh( &hiwdg );
		uint8_t val_str[20];
		for( int i = 0; i  <value_len; i++)
		{
			val_str[i] = uartRxBuffRead();
		}
		if ( value_format == 1 ) {
			for ( int i = 0; i < value_len; i++ ) {
				value[ i ] = val_str[ i ];
			}
			value[ value_len ] = '\0';
		}else{
			(*value) = atoi( val_str );

		}
	}
	else
	{	value = 0;
		//uartRxBuff.start = (uartRxBuff.start + uartRxBuffGetUsedSize() ) % UART_RX_BUFF_SIZE;
	}
	return match;

}

uint8_t findMatchAndValueBlocking(uint8_t * expect, uint8_t exp_len, int32_t * value, uint8_t value_start, uint8_t value_len, uint8_t value_format)
// returns true if match, value contains numeric value
// else returns false, value = 0
{

	uint8_t match_position;
	uint8_t match = compareResponse(expect, exp_len, &uartRxBuff.data[uartRxBuff.start], uartRxBuffGetUsedSize(), &match_position);
	if( match )
	{
		/*
		HAL_UART_Transmit( &huart2, "Match found. Position:", strlen("Match found. Position:"), 1000 );
		char string[5];
		get_dec_str(&string, 5, match_position);
		HAL_UART_Transmit( &huart2, string, 5, 1000 );
		HAL_UART_Transmit( &huart2, "\n", strlen("\n"), 1000 );
		*/
		// parse value starting at match position according to format
		uint8_t start_old = uartRxBuff.start;
		uartRxBuff.start = (uartRxBuff.start + value_start + match_position ) % UART_RX_BUFF_SIZE;
		HAL_IWDG_Refresh( &hiwdg );
		uint8_t val_str[20];
		for( int i = 0; i  <value_len; i++)
		{
			val_str[i] = uartRxBuffRead();
		}
		if ( value_format == 1 ) {
			for ( int i = 0; i < value_len; i++ ) {
				value[ i ] = val_str[ i ];
			}
			value[ value_len ] = '\0';
		}else{
			(*value) = atoi( val_str );

		}
	}
	else
	{	value = 0;
		//uartRxBuff.start = (uartRxBuff.start + uartRxBuffGetUsedSize() ) % UART_RX_BUFF_SIZE;
	}
	return match;

}
