/*
 * uartRxBuff.h
 *
 *  Created on: May 25, 2017
 *      Author: fiala
 */

#ifndef UARTRXBUFF_H_
#define UARTRXBUFF_H_

#include "stm32l0xx_hal.h"
#include "main.h"
#include "common.h"
#include "iwdg.h"

#define UART_RX_BUFF_SIZE 250

struct uartRxBuff_t
{
	uint8_t data[UART_RX_BUFF_SIZE];
	uint8_t start;
	uint8_t end;
};

extern struct uartRxBuff_t uartRxBuff;

uint8_t found_match_position;

void uartRxBuffInit(void);
void uartRxBuffWrite(uint8_t data);
void uartRxBuffClear(void);
uint8_t uartRxBuffIsEmpty();
uint8_t uartRxBuffRead();
uint8_t uartRxBuffGetUsedSize();
uint8_t compareResponse(uint8_t * expect, uint8_t exp_len, uint8_t * compare, uint8_t cmp_len, uint8_t * match_position );
uint8_t findMatchBlocking(uint8_t * expect, uint8_t exp_len);
uint8_t findMatchNonblocking(uint8_t * expect, uint8_t exp_len, uint32_t timeout );
uint8_t findMatchAndValueBlocking(uint8_t * expect, uint8_t exp_len, int32_t * value, uint8_t value_start, uint8_t value_len, uint8_t value_format);
uint16_t uartRxReadData( uint8_t pos, uint8_t size );
int32_t uartRxRead4Data( uint8_t pos );
#endif /* UARTRXBUFF_H_ */
